#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define ld long double

const int INF = 1e18;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) cin >> a[i];
        vector<int> b(n);
        for (int i = 0; i < n; ++i) cin >> b[i];
        vector<pair<int, int>> c(n);
        for (int i = 0; i < n; ++i) c[i] = {a[i] + b[i], i};
        sort(c.begin(), c.end());
        vector<int> pref(n + 1, 0);
        for (int i = 0; i < n; ++i) pref[i + 1] = pref[i] + a[c[i].second];
        vector<int> suf(n + 1, 0);
        for (int i = 0; i < n; ++i) suf[i + 1] = suf[i] - b[c[n - i - 1].second];
        int B = 0;
        for (int i = 0; i < n; ++i) B += b[i];
        bool ans = false;
        for (int i = 0; i < n; ++i) {
            B -= b[i];
            int ind = upper_bound(c.begin(), c.end(), make_pair(B, INF)) - c.begin();
            int sum = pref[ind] + suf[n - ind] + B * (n - ind);
            sum -= min(a[i], B - b[i]);
            if (sum + a[i] >= B) ans = true;
            B += b[i];
        }
        cout << (ans ? "YES\n" : "NO\n");
    }
    return 0;
}
