#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3", "Ofast", "unroll-loopps", "unswitch-loops", "fast-math", "no-stack-protector")

/*


 */

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()
typedef long long ll;
#define int long long
#define pii pair<int, int>

#define fi first
#define se second
#define ld long double
#define mp make_pair
const int max_n = 301;
const int inf = 1e12;
const ld eps = 1e-6;

int x[max_n], y[max_n];

int n;
vector<pii> a, b;

struct line {
    ld k, b;
    int t;
    line() : k(), b(), t(){}
    line(int id1, int id2) {
        if (x[id1] == x[id2]) {
            t = 0;
            b = x[id1];
        }else {
            k = (ld) (y[id1] - y[id2]) / (x[id1] - x[id2]);
            b = y[id1] - k * x[id1];
            t = 1;
        }
    }
};

pair<ld, ld> inter(line a, line b) {
    if (a.t == 0 && b.t == 0) {
        if (abs(a.b - b.b) < eps) {
            return mp(a.b, 0);
        }
        return mp(inf, inf);
    }
    if (b.t == 0) swap(a, b);
    if (a.t == 0) {
        ld x = a.b;
        ld y = b.k * x + b.b;
        return mp(x, y);
    }
    if (abs(a.k - b.k) < eps) return mp(inf, inf);
    ld x = (b.b - a.b) / (a.k - b.k);
    ld y = (a.k * x + a.b);
    return mp(x, y);
}

bool intersec(int id1, int id2, int id3, int id4) {
    line a(id1, id2), b(id3, id4);
    pair<ld, ld> q = inter(a, b);
    if (abs(q.fi - inf) < eps) return false;
    if (q.fi - max(x[id1], x[id2]) > -eps) return false;
    if (min(x[id1], x[id2]) - q.fi > -eps) return false;
    return true;
}


pii add_el(int& id) {
    while(id < size(a)) {
        bool good = true;
        for(pii i : b) {
            if (intersec(a[id].fi, a[id].se, i.fi, i.se)) good = false;
        }
        if (!good) id++;
    }
    if (id == size(a)) return make_pair(1337, 1337);
    return a[id];
}


void solve() {
    cin >> n;
    for(int i = 0; i < n;i++)
        cin >> x[i] >> y[i];

    for(int i = 0;i < n;i++) {
        for(int j = i + 1;j < n;j++)
            a.emplace_back(i, j);
    }

    int cnt = 0;
    int id = 0;
    while(id != size(a)) {
        pii q = add_el(id);
        if (id == size(a)) break;
        cnt++;
        b.emplace_back(q);
    }

    cout << 2 - (cnt % 2) << endl;

    b.clear();
    id = 0;
    if (cnt % 2 == 1) {
        pii q = add_el(id);
        b.emplace_back(q);
        cout << q.fi + 1 << " " << q.se + 1 << endl;
    }

    int i1, i2 = -1;
    while(true) {
        cin >> i1 >> i2;
        if (i1 == 0 && i2 == 0) break;
        i1--; i2--;
        b.emplace_back(i1, i2);

        pii q = add_el(id);
        b.emplace_back(q);
        cout << q.fi + 1 << " " << q.se + 1 << endl;
    }
}


signed main()
{
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    solve();
}
