#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

const int N = 1e5;

int n;
ll W;
pii a[N];
ve<int> p;
ve<int> best_p;
ll best;

void solve(ve<int> p) {
    ll cur = W;
    ll ans = 0;
    ve<int> take_p;
    fe(x, p) {
        if(cur - a[x].fi >= 0) {
            cur -= a[x].fi;
            ans += a[x].se;
            take_p.pb(x);
        }
    }
    if(umx(best, ans)) {
        best_p = take_p;
    }
}

void check(ve<int> p) {
    ll cur = W;
    ll ans = 0;

    ve<int> take_p;
    fe(x, p) {
        if(cur - a[x].fi >= 0) {
            cur -= a[x].fi;
            ans += a[x].se;
            take_p.pb(x);
        } else {
            if(umx(best, ans)) best_p = take_p;
            take_p.clear();
            cur = W;
            ans = 0;
        }
    }
    if(umx(best, ans)) {
        best_p = take_p;
    }
}

void solve() {
    best = 0;
    cin >> n >> W;

    W = (W * 3) / 2;

    fr(i, 0, n - 1) {
        cin >> a[i].fi >> a[i].se;
    }

    p.resize(n);
    iota(all(p), 0);

    sort(all(p), [&](int x, int y) {
        return a[x].fi < a[y].fi || (a[x].fi == a[y].fi && a[x].se > a[y].se);
    });
    solve(p);
    check(p);
    sort(all(p), [&](int x, int y) {
        return a[x].se > a[y].se || (a[x].se == a[y].se && a[x].fi < a[y].fi);
    });
    solve(p);
    check(p);
    sort(all(p), [&](int x, int y) {
        return (ld)a[x].se / a[x].fi > (ld)a[y].se / a[y].fi;
    });
    solve(p);
    check(p);

    int timer = 0;
    while(timer < 100) {
        shuffle(all(p), rng);
        solve(p);
        check(p);
        timer++;
    }

    cout << sz(best_p) << "\n";
    fe(x, best_p) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int test;
    cin >> test;

    while(test--) {
        solve();
    }

    return 0;
}

/*
1
3 10
5 100
5 100
4 99

1
3 100
97 100
98 101
99 90

1
3 100
55 100
99 150
200 200
*/
