#include <bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define fileio freopen("output.txt", "w", stdout); freopen("input.txt", "r", stdin);

signed main() {
    fastio
//    fileio
    int q;
    cin >> q;
    while (q--) {
        int n, W;
        cin >> n >> W;
        vector<tuple<int, int, int>> wc (n);
        for (int i = 0; i < n; ++i) {
            int w, c;
            cin >> w >> c;
            wc[i] = {w, c, i};
        }
        sort(wc.begin(), wc.end());
        if (n * W <= 100000000) {
            vector<int> dp (W + 1, -1);
            vector<int> parent (W + 1, -1);
            dp[0] = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = W; j >= get<0>(wc[i]); --j) {
                    if (dp[j - get<0>(wc[i])] == -1) continue;
                    int c1 = j - get<0>(wc[i]);
                    if (dp[j] < dp[c1] + get<1>(wc[i])) {
                        parent[j] = i;
                        dp[j] = dp[c1] + get<1>(wc[i]);
                    }
                }
            }
            int mx = 0;
            for (int i = 1; i <= W; ++i) {
                if (dp[mx] < dp[i]) mx = i;
            }
            int who = parent[mx];
            int where = mx;
            vector<int> ans;
            while (who != -1) {
                ans.push_back(get<2>(wc[who]));
                where -= get<0>(wc[who]);
                who = parent[where];
            }
            cout << ans.size() << '\n';
            for (int i = 0; i < ans.size(); ++i) {
                cout << ans[i] + 1 << ' ';
            }
            cout << '\n';
        } else {
            int sm = get<0>(wc[0]);
            vector<int> who;
            int where = 0;
            while (sm <= 3 * W / 2) {
                who.push_back(get<2>(wc[where]));
                ++where;
                sm += get<0>(wc[where]);
            }
            cout << who.size() << '\n';
            for (int i = 0; i < who.size(); ++i) {
                cout << who[i] + 1 << ' ';
            }
            cout << '\n';
        }
    }
}