import java.util.*;
import java.io.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);


    static long ans = 0, sum = 0, n, k;
    static TreeMap<Long, Long> cnt = new TreeMap<>();

    public static void main(String[] args) throws IOException {
        n = sc.nextLong();
        k = sc.nextLong();
        rec(1);
        pw.print(ans);
        pw.close();
    }

    static void rec(long num) {
        if (num == 16) {
            if (sum != n)
                return;
            long res = 1;
            for (long count : cnt.values())
                res *= (count + 1);
            ans += res;
            return;
        }
        for (int i = 0; i <= n - sum; i += num) {
            sum += i;
            cnt.put(num, i / num);
            rec(num + 1);
            cnt.remove(num);
            sum -= i;
        }
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public Scanner(String file) throws FileNotFoundException {
        br = new BufferedReader(new FileReader(file));
    }

    public boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public String next() throws IOException {
        hasNext();
        return st.nextToken();
    }
}
