#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <climits>
#include <random>
#include <unordered_set>
#include <queue>
#include <bitset>

using namespace std;

#pragma warning (disable : 4996)

long long res = 0, n, k;
long long d[100];

long long count1(long long n1, long long k1) {
    vector<vector<long long>> dp(n1 + 1, vector<long long>(k1 + 1, 0));
    dp[0][0] = 1;
    for (long long i = 0; i <= n1; i++) {
        for (long long j = 1; j <= k1; j++) {
            for (long long t = i; t >= 0; t--)
                dp[i][j] += dp[t][j - 1];
        }
    }
    return dp[n1][k1];
}

void gen(long long sum, long long count, long long last) {
    if (sum == n) {
        long long ans = 1;
        for (long long i = 1; i <= n; i++) {
            if (d[i] == 0)
                continue;
            ans *= count1(d[i], k);
        }
        res += ans;
        return;
    }
    for (long long i = 1; i <= last; i++) {
        if (sum + i > n) 
            break;
        d[i]++;
        gen(sum + i, count + 1, i);
        d[i]--;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef  _DEBUG
    freopen("input.txt", "r", stdin);
#endif 
    cin >> n >> k;
    gen(0, 0, n);
    cout << res;
    return 0;
}