﻿/*#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

#include <algorithm>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;


#define ll long long
#define ld long double
#define int long long

#define pii pair<int, int>
#define pll pair<int, ll>
#define vi vector<int>
#define vl vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vvi vector<vector<int>>
#define vvl vector<vector<ll>>
#define vpii vector<pii>
#define vpll vector<pll>

const int N = 501;
const int inf = 1e9;
const ll INF = 1e18;
const ll M = 1e9 + 7;
const string io[2]{ "NO", "YES" };

int gcd(int a, int b)
{
    if (!b) return a;
    return gcd(b, a % b);
}
void vcin(vector<int>& x)
{
    for (int& element : x)
    {
        cin >> element;
    }
}
void vcout(vector<int>& x)
{
    for (int& element : x)
    {
        cout << element;
    }
}

void solve()
{
    int n; cin >> n;
    int r = (n / 3) * 3;
    vs a;
    int x = 1;
    while (x * (1 << x) < 1 << r)
        ++x;
    int size = x;
    for (int i = 0; i < 1 << size; ++i)
    {
        string now = "";
        for (int j = 0; j < size; ++j)
        {
            now += char('0' + ((i & 1 << j) > 0));
        }
        a.push_back(now);
    }

    if (n == 1)
    {
        cout << "10\n";
        return;
    }
    else if (n == 2)
    {
        cout << "1001\n";
        return;
    }

    if (n == r)
    {
        for (auto aa : a)
            cout << aa;
    }
    else if (n - r == 1)
    {
        for (auto aa : a)
            cout << aa;
        for (int i = 0; i < a.size(); ++i)
        {
            if (i * 2 + 1 >= a.size())
                break;
            swap(a[2 * i], a[2 * i + 1]);
        }
        for (auto aa : a)
            cout << aa;
    }
    else if (n - r == 2)
    {
        for (auto aa : a)
            cout << aa;
        for (int i = 0; i < a.size(); ++i)
        {
            if (i * 2 + 1 >= a.size())
                break;
            swap(a[2 * i], a[2 * i + 1]);
        }
        for (auto aa : a)
            cout << aa;
        for (int i = 0; i < a.size(); ++i)
        {
            if (i * 2 + 1 >= a.size())
                break;
            swap(a[2 * i], a[2 * i + 1]);
        }
        for (int i = 0; i < a.size(); ++i)
        {
            if (4 * i + 3 >= a.size())
                break;
            swap(a[4 * i + 1], a[4 * i + 3]);
        }
        for (auto aa : a)
            cout << aa;
        for (int i = 0; i < a.size(); ++i)
        {
            if (i * 2 + 1 >= a.size())
                break;
            swap(a[2 * i], a[2 * i + 1]);
        }
        for (auto aa : a)
            cout << aa;
    }
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1; //cin >> t;
    while (t--)
        solve();
}