﻿/*#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

#include <algorithm>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;


#define ll long long
#define ld long double
#define int long long

#define pii pair<int, int>
#define pll pair<int, ll>
#define vi vector<int>
#define vl vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vvi vector<vector<int>>
#define vvl vector<vector<ll>>
#define vpii vector<pii>
#define vpll vector<pll>

const int N = 501;
const int inf = 1e9;
const ll INF = 1e18;
const ll M = 1e9 + 7;
const string io[2]{ "NO", "YES" };

int gcd(int a, int b)
{
    if (!b) return a;
    return gcd(b, a % b);
}
void vcin(vector<int>& x)
{
    for (int& element : x)
    {
        cin >> element;
    }
}
void vcout(vector<int>& x)
{
    for (int& element : x)
    {
        cout << element;
    }
}

void solve()
{
    int n; cin >> n;
    int m1 = 0, m2 = 0;
    vi a(n), b(n);
    vcin(a);
    vcin(b);
    int sum = 0, sm = 0;
    for (int i = 0; i < n; ++i)
    {
        sum += a[i];
        sm += b[i];
        if (a[i] + b[i] > m1)
        {
            m2 = m1;
            m1 = a[i] + b[i];
        }
        else if (a[i] + b[i] > m2)
        {
            m2 = a[i] + b[i];
        }
    }
    bool ok = false;
    for (int i = 0; i < n; ++i)
    {
        int m = m1;
        if (a[i] + b[i] == m)
            m = m2;
        ok |= (sum >= sm - b[i] && (sum >= m));
    }
    cout << io[ok] << '\n';
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1; cin >> t;
    while (t--)
        solve();
}