﻿/*#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

#include <algorithm>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;


#define ll long long
#define ld long double
#define int long long

#define pii pair<int, int>
#define pll pair<int, ll>
#define vi vector<int>
#define vl vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vvi vector<vector<int>>
#define vvl vector<vector<ll>>
#define vpii vector<pii>
#define vpll vector<pll>

const int N = 50;
const int inf = 1e9;
const ll INF = 1e18;
const ll M = 1e9 + 7;
const string io[2]{ "NO", "YES" };

int gcd(int a, int b)
{
    if (!b) return a;
    return gcd(b, a % b);
}
void vcin(vector<int>& x)
{
    for (int& element : x)
    {
        cin >> element;
    }
}
void vcout(vector<int>& x)
{
    for (int& element : x)
    {
        cout << element;
    }
}

int ans = 0;
int n, k;
int C[N][N];

void view(vpii& a) {
    int res = 1;
    for (auto& x : a) {
        res *= C[x.second + k - 1][k - 1];
    }
    ans += res;
}

void gen(vpii& a, int sum, int n) {
    if (sum == n) {
        view(a);
        return;
    }
    if (a.back().first + sum <= n) {
        a.back().second++;
        gen(a, sum + a.back().first, n);
        a.back().second--;
    }
    for (int i = a.back().first - 1; i >= 1; i--) {
        if (sum + i <= n) {
            a.emplace_back(i, 1);
            gen(a, sum + i, n);
            a.pop_back();
        }
    }
}

void solve()
{
    for (int i = 0; i < N; ++i)
    {
        for (int j = 0; j < N; ++j)
        {
            if (j > i)
                C[i][j] = 0;
            else if (i == j)
                C[i][j] = 1;
            else
            {
                C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
            }
        }
    }

    /*
    int n, m, s; cin >> n >> m >> s;
    map<int, int> p;
    for (int i = 0; i < n; ++i)
    {
        int x; cin >> x;
        ++p[x];
    }
    */
    cin >> n >> k;
    vpii a;
    for (int i = n; i >= 1; i--) {
        a.emplace_back(i, 1);
        gen(a, i, n);
        a.pop_back();
    }
    cout << ans << "\n";
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;// cin >> t;
    while (t--)
        solve();
}