﻿/*#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

#include <algorithm>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;


#define ll long long
#define ld long double
#define int long long

#define pii pair<int, int>
#define pll pair<int, ll>
#define vi vector<int>
#define vl vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vvi vector<vector<int>>
#define vvl vector<vector<ll>>
#define vpii vector<pii>
#define vpll vector<pll>

const int N = 50;
const int inf = 1e9;
const ll INF = 1e18;
const ll M = 1e9 + 7;
const string io[2]{ "NO", "YES" };

int gcd(int a, int b)
{
    if (!b) return a;
    return gcd(b, a % b);
}
void vcin(vector<int>& x)
{
    for (int& element : x)
    {
        cin >> element;
    }
}
void vcout(vector<int>& x)
{
    for (int& element : x)
    {
        cout << element;
    }
}

void solve()
{
    int n, m, s;
    cin >> n >> m >> s;
    vector <int> v(m);
    for (int i = 0; i < m; i++) cin >> v[i];

    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    int need = m;
    m = v.size();
    int ans = 0;
    for (int i = 0; i < m; i++) {
        int L = v[i], R = 1e10, mid;
        while (L != R - 1) {
            mid = (L + R) / 2;
            int r = upper_bound(v.begin(), v.end(), mid) - v.begin() - 1;
            if (s + r - i + 1 >= mid - v[i] + 1) L = mid;
            else R = mid;
        }
        int r2 = upper_bound(v.begin(), v.end(), L) - v.begin() - 1;
        int r1 = upper_bound(v.begin(), v.end(), v[i] + need - 1) - v.begin();
        int last = (i ? v[i - 1] : 0);
        int over = max(0ll, v[i] + need - 1 - n);
        if (v[i] + need - 1 > L) continue;
        int can = min(v[i] - last, L - v[r1 - 1] - (r2 - r1 + 1) + 1) - over;
        ans += can;
        //cout << i << " " << L << " " << can << " " << r2 << " " << r1 << endl;
    }
    cout << ans << endl;
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;// cin >> t;
    while (t--)
        solve();
}