#include <functional>
#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx")

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = 2e5 + 1;
const ll mod = 1000000007;

void ex(ll exitCode = 0) {
#ifdef _DEBUG
	//system("pause");
#endif // _DEBUG
	exit(exitCode);
}

ll k;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t1, v1, t2, v2;
	cin >> t1 >> v1 >> t2 >> v2;
	if (t2 < 0 && v2 >= 10) {
		cout << "A storm warning for tomorrow! Be careful and stay home if possible!";
	}
	else if (t2 < t1) cout << "MCHS warns! Low temperature is expected tomorrow.";
	else if (v2 > v1) cout << "MCHS warns! Strong wind is expected tomorrow.";
	else cout << "No message";
	ex();
}