#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <queue>
#include <iomanip>
#include <cstdlib>
#include <fstream>

#define int long long

using namespace std;

vector < int > a, b, ind;

bool comp(int i, int j)
{
    if(b[i] != b[j])
        return b[i] > b[j];
    return a[i] < a[j];
}

bool comp1(int i, int j)
{
    return b[i] - a[i] < b[j] - a[j];
}

queue < int > q;

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--)
    {
        int n;
        cin >> n;
        a.clear();
        b.clear();
        ind.clear();
        a.resize(n);
        b.resize(n);
        ind.resize(n);
        for(int i = 0; i < n; i++)
            cin >> a[i];
        for(int i = 0; i < n; i++)
            cin >> b[i];
        for(int i = 0; i < n; i++)
            ind[i] = i;
        vector < int > a1 = a, b1 = b, ind1 = ind;
        bool f1 = 0, f2 = 0;
        ///------------------------------------------------------------------------------------------
        sort(ind.begin(), ind.end(), comp);
//        for(int i=0;i<n;i++)
//            cout<<ind[i]<<" ";
        for(int i = 0; i < n; i++)
            q.push(ind[i]);
        for(int i = 1; i < n; i++)
        {
//            cout << ind[i] << " ";
            while(b[ind[i]] > 0 && !q.empty())
            {
                if(q.front() == ind[i])
                    q.pop();
                if(q.empty())
                    break;
                if(b[ind[i]] > a[q.front()])
                {
                    b[ind[i]] -= a[q.front()];
                    a[q.front()] = 0;
                    q.pop();
                }
                else
                {
                    a[q.front()] -= b[ind[i]];
                    b[ind[i]] = 0;
                }
                if(q.empty())
                    break;
                if(q.front() == ind[i])
                    q.pop();
            }
            q.push(ind[i]);
        }
        while(!q.empty())
            q.pop();
        for(int i = 1; i < n; i++)
            if(b[ind[i]] != 0)
            {
                f1 = 1;
                break;
            }
        ///-----------------------------------------------------------
        b = b1;
        a = a1;
        ind = ind1;
        sort(ind.begin(), ind.end(), comp1);
        sort(ind.begin() + 1, ind.end(), comp);
//        for(int i=0;i<n;i++)
//            cout<<ind[i]<<" ";
        for(int i = 0; i < n; i++)
            q.push(ind[i]);
        for(int i = 1; i < n; i++)
        {
//            cout << ind[i] << " ";
            while(b[ind[i]] > 0 && !q.empty())
            {
                if(q.front() == ind[i])
                    q.pop();
                if(q.empty())
                    break;
                if(b[ind[i]] > a[q.front()])
                {
                    b[ind[i]] -= a[q.front()];
                    a[q.front()] = 0;
                    q.pop();
                }
                else
                {
                    a[q.front()] -= b[ind[i]];
                    b[ind[i]] = 0;
                }
                if(q.empty())
                    break;
                if(q.front() == ind[i])
                    q.pop();
            }
            q.push(ind[i]);
        }
        while(!q.empty())
            q.pop();
        for(int i = 1; i < n; i++)
            if(b[ind[i]] != 0)
            {
                f2 = 1;
                break;
            }
        ///-----------------------------------------------------------
        if(f1 == 1 && f2 == 1)
            cout << "NO\n";
        else
            cout << "YES\n";
    }
    return 0;
}
