#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <string>
#include <set>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;

ll pow(ll n) {
    if (n == 0) return 1;
    if (n == 1) return 2;
    ll k = pow(n / 2);
    k *= k;
    if (n % 2 == 1) k *= 2;
    return k;
}

vector<short> preob(ll n,ll t) {
    vector<short> a(0);
    while (n > 0) {
        a.push_back(n % 2);
        n /= 2;
    }
    ll l = a.size();
    for (ll i = l; i < t; i++) a.push_back(0);
    return a;
}

int main() {
    ll n;
    cin >> n;
    ll t = 1, p = 2;
    while (p + t < n) {
        p *= 2;
        t++;
    }
    ll k = pow(n),r=pow(t),s=0;
    vector<short> a;
    while (k > 0) {
        a = preob(s, r);
        for (ll i = r - 1; i > -1; i--) cout << a[i];
        s++;
        k -= r;
    }
}