#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <assert.h>
#include <string>
#include <deque>
#include <iomanip>
#include <map>

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	return bin_pow(a, n - 1) * a;
}

ll ans = 0, ans1 = 0;
int n, k;
vector<int>arr;

void kol(int open, int color) {
	if (color == 1) {
		ans1++;
		return;
	}
	for (int i = 0; i <= open; i++) {
		kol(open - i, color - 1);
	}
}

void get_ans() {
	ll now = 1;
	for (auto i : arr) {
		kol(i, k);
		now *= ans1;
		ans1 = 0;
	}
	ans += now;
}

void gen(int x, int sum) {
	if (x == 1) {
		arr[x] = n - sum;
		get_ans();
		return;
	}
	for (int i = 0; i * x + sum <= n; i++) {
		arr[x] = i;
		gen(x - 1, sum + x * i);
	}
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	cin >> n>>k;
	arr.resize(n + 1);
	gen(n, 0);
	cout << ans;
	return 0;
}