﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>

#define rep(i, n) for(ll i = 0; i < n; ++i)
#define in(x, a) for(auto x : a)
#define inl(x, a) for(auto& x : a)

using namespace std;

using ll = long long;
ll const INF = 1e9;
ll const MOD = 1e9 + 7;

int n, m, s;

set <int> cards1;

vector <int> cards;
vector <pair <int, int>> scanline;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> s;
    int el;
    for (int i = 0; i < m; ++i) {
        cin >> el;
        cards1.insert(el);
    }
    for (auto el : cards1) {
        cards.push_back(el);
    }
    int answer = 0;
    for (int i = 0; i < cards.size(); ++i) {
        if (i + m - s - 1 > cards.size() - 1)
            break;
        if (cards[i + m - s - 1] - cards[i] < m) {
            scanline.emplace_back(max(1, cards[i + m - s - 1] - m + 1), -1);
            scanline.emplace_back(cards[i], 1);
        }
    }
    sort(scanline.begin(), scanline.end());
    int cur = 0, last;
    for (auto el : scanline) {
        if (el.second == -1 && cur == 0) {
            last = el.first;
        } else if (el.second == 1 && cur == 1){
            answer += el.first - last + 1;
        }
        cur -= el.second;
    }
    cout << answer;
}