//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2")
// 293206GT
#include <array>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <climits>
#include <limits>
#include <set>
#include <map>
#include <queue>
//#include <unordered_map>
//#include <unordered_set>
//#include <unordered_set>
//#include <stack>
#include <string>
#include <algorithm>
#include <random>
#include <bitset>
#include <chrono>
//#include <cstdlib>
//#include <cstring>

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//template<class T>
//using OrderedSet = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
//#define int ll
// #define int long long
using namespace std;
#define put(a) cout << (a) << '\n'
#define sqr(x) ((x) * (x))
typedef pair<int, int> pii;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef unsigned long long ull;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpii;
#define ts to_string
#define sts string ts

sts(string s) { return s; }

sts(bool b) { return b ? "true" : "false"; }

sts(char c) { return string(1, c); }

sts(const char *s) { return (string) s; }

template<class A, class B>
sts(pair<A, B>);

template<class T>
sts(T v) {
    string s = "{", sep = "";
    for (auto x : v) {
        s += sep;
        sep = ", ";
        s += ts(x);
    }
    return s + "}";
}

template<class A, class B>
sts(pair<A, B> p) { return "(" + ts(p.first) + ", " + ts(p.second) + ")"; }

void dbgPrint() { cerr << endl; }

template<class A, class... B>
void dbgPrint(A a, B... b) {
    cerr << ' ' << ts(a);
    dbgPrint(b...);
}

#ifdef LOCAL
#define dbg(...) cerr << "line #" << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbgPrint(__VA_ARGS__)
#else
#define dbg(...)
#endif

#define sz(a) (int) (a).size()
#define len(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define rep(x, y, a) for (int x = (y); x < (int)(a); ++x)
#define asd(n) rep(i, 0, n)
#define jkl(n) rep(j, 0, n)
#define UB upper_bound
#define LB lower_bound
#define mp make_pair
namespace IO {

    template<class A, class B>
    ostream &operator<<(ostream &out, vector<pair<A, B>> a);

    template<class A>
    ostream &operator<<(ostream &out, vector<A> a);

    template<class A, class B>
    ostream &operator<<(ostream &out, pair<A, B> a) {
        out << a.first << " " << a.second;
        return out;
    }

    template<class A, class B>
    ostream &operator<<(ostream &out, vector<pair<A, B>> a) {
        for (pair<A, B> x : a)
            out << x.first << " " << x.second << '\n';
        return out;
    }

    template<class A>
    ostream &operator<<(ostream &out, vector<A> a) {
        for (A x : a) out << x << ' ';
        return out;
    }

    template<class A, class B>
    istream &operator>>(istream &in, pair<A, B> &a) {
        in >> a.first >> a.second;
        return in;
    }

    template<class A>
    istream &operator>>(istream &in, vector<A> &a) {
        for (A &x : a) in >> x;
        return in;
    }
}  // namespace IO

template<class A, class B>
inline int chkmax(A &a, B b) {
    if (a < (A) b) {
        a = (A) b;
        return 1;
    }
    return 0;
}

template<class A, class B>
inline int chkmin(A &a, B b) {
    if (a > (A) b) {
        a = (A) b;
        return 1;
    }
    return 0;
}

using namespace IO;

void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
    // cin >> q;
    while (q--) solve();
}

ostream& operator << (ostream &out, __int128 x) {
    string s;
    for (; x; x /= 10) {
        s.push_back('0' + x % 10);
    }
    if (s.empty()) s.push_back('0');
    reverse(all(s));
    return out << s;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<__int128> pk(n + 1, 1);
    for (int i = 1; i <= n; i++) {
        pk[i] = pk[i - 1] * k;
    }

    vector<vector<__int128>> C(n + k + 3, vector<__int128>(n + k + 3, 0));
    for (int i = 0; i <= n + k + 2; i++) {
        C[i][0] = 1;
        for (int j = 1; j <= i; j++) {
            C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
        }
    }

    auto calc = [&](vector<int> dels) {
        __int128 cur = 1;
        for (int i = 0; i < len(dels);) {
            int j = i;
            while (j < len(dels) && dels[j] == dels[i]) j++;
            cur *= C[j - i + k - 1][k - 1];
            i = j;
        }
        return cur;
    };

    __int128 ans = 0;
    for (int mask = 1; mask < (1 << n); mask++) {
        vector<int> ones;
        ones.emplace_back(-1);
        for (int i = 0; i < n; i++) {
            if ((mask >> i) % 2) ones.emplace_back(i);
        }
        if (ones.back() != n - 1) continue;
        vector<int> dels;
        for (int i = 1; i < len(ones); i++) {
            dels.emplace_back(ones[i] - ones[i - 1]);
        }
        if (!is_sorted(all(dels))) continue;
        ans += calc(dels);
    }
    cout << ans << '\n';
}
