#include <bits/stdc++.h>

using namespace std;

#define int long long

struct pt
{
    int x, y;
};

const int MAXN = 307;

pt a[MAXN];

pt operator -(pt a, pt b)
{
    pt c;
    c.x = a.x - b.x;
    c.y = a.y - b.y;
    return c;
}

int vec_product(pt a, pt b)
{
    return a.x * b.y - a.y * b.x;
}

bool intersect(pt a, pt b, pt c, pt d)
{
    return ((vec_product(c - a, b - a) * vec_product(d - a, b - a) >= 0) || (vec_product(a - c, d - c) * vec_product(b - c, d - c) >= 0));
}

bool used[MAXN][MAXN];
bool used2[MAXN][MAXN];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].x >> a[i].y;
    }
    vector<pair<pt, pt>> cur;
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            if (used[i][j])
            {
                continue;
            }
            bool fl = true;
            for (auto el : cur)
            {
                if (!intersect(a[i], a[j], el.first, el.second))
                {
                    fl = false;
                    break;
                }
            }
            if (fl)
            {
                used[i][j] = true;
                cur.push_back({a[i], a[j]});
            }
        }
    }
    if (cur.size() % 2 == 0)
    {
        cout << 2 << endl;
        cur = {};
        int x1, y1;
        cin >> x1 >> y1;
        --x1; --y1;
        if (x1 > y1)
        {
            swap(x1, y1);
        }
        used2[x1][y1] = true;
        cur.push_back({a[x1], a[y1]});
        for (int i = 0; i < n; ++i)
        {
            for (int j = i + 1; j < n; ++j)
            {
                if (used2[i][j])
                {
                    continue;
                }
                bool fl = true;
                for (auto el : cur)
                {
                    if (!intersect(a[i], a[j], el.first, el.second))
                    {
                        fl = false;
                        break;
                    }
                }
                if (fl)
                {
                    cout << i + 1 << " " << j + 1 << endl;
                    used2[i][j] = true;
                    cur.push_back({a[i], a[j]});
                    int x1, y1;
                    cin >> x1 >> y1;
                    if (x1 == 0 && y1 == 0)
                    {
                        return 0;;
                    }
                    --x1; --y1;
                    if (x1 > y1)
                    {
                        swap(x1, y1);
                    }
                    used2[x1][y1] = true;
                    cur.push_back({a[x1], a[y1]});
                }
            }
        }
    }
    else
    {
        cout << 1 << endl;
        cur = {};
        for (int i = 0; i < n; ++i)
        {
            for (int j = i + 1; j < n; ++j)
            {
                if (used2[i][j])
                {
                    continue;
                }
                bool fl = true;
                for (auto el : cur)
                {
                    if (!intersect(a[i], a[j], el.first, el.second))
                    {
                        fl = false;
                        break;
                    }
                }
                if (fl)
                {
                    cout << i + 1 << " " << j + 1 << endl;
                    used2[i][j] = true;
                    cur.push_back({a[i], a[j]});
                    int x1, y1;
                    cin >> x1 >> y1;
                    if (x1 == 0 && y1 == 0)
                    {
                        return 0;;
                    }
                    --x1; --y1;
                    if (x1 > y1)
                    {
                        swap(x1, y1);
                    }
                    used2[x1][y1] = true;
                    cur.push_back({a[x1], a[y1]});
                }
            }
        }
    }
    return 0;
}
