#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()
#define pb push_back

int n, m;

vector<vector<char>> g, gn;
vector<vector<int>> d;
vector<vector<vector<int>>> w;
int t = 0;

vector<vector<int>> gr;
vector<int> color, used;

bool big(char c) {
	return ('A' <= c && c <= 'Z');
}

bool is(int x, int y) {
	return (0 <= x && x < n && 0 <= y && y < m);
}

bool free(int x, int y) {
	if (is(x, y) && g[x][y] == '.') return 1;
	return 0;
}

void dfs_zero(int v) {
	if (!used[v]) return;
	used[v] = 0;
	for (auto e : gr[v]) {
		dfs_zero(e);
	}
	return;
}

int dfs_count(int v, int p) {
	if (used[v]) return 0;
	used[v] = 1;
	int ans = color[v];
	for (auto e : gr[v]) {
		if (e == p) continue;
		ans += dfs_count(e, v);
	}
	return ans;
}

int dfs_fill(int v, int p, int t) {
	if (used[v]) return 0;
	used[v] = 1;
	int can = 1;
	for (auto e : gr[v]) {
		if (used[e] && color[e] == t) can = 0;
	}
	if (can) color[v] = t;
	else color[v] = 0;
	int ans = 1;
	for (auto e : gr[v]) {
		if (e == p) continue;
		ans += dfs_fill(e, v, t ^ 1);
	}
	return ans;
}

int ind(int x, int y) {
	return ((x % 3) * 3 + (y % 3));
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	g.assign(n, vector<char>(m, 0));
	gn.assign(n, vector<char>(m, 0));
	d.assign(n, vector<int>(m, -1));
	w.assign(n, vector<vector<int>>(m, vector<int>(0, 0)));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> g[i][j];
		}
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = 0; j < m; j++) {
			// (i, j) (i + 1, j)
			if (g[i][j] == g[i + 1][j] && g[i][j] != '.') {
				// divan
				d[i][j] = t;
				d[i + 1][j] = t++;
				if (big(g[i][j])) {
					// right
					if (free(i, j + 1) && free(i + 1, j + 1)) {
						w[i][j + 1].push_back(d[i][j]);
						w[i + 1][j + 1].push_back(d[i][j]);
					}
				} else {
					// left
					if (free(i, j - 1) && free(i + 1, j - 1)) {
						w[i][j - 1].push_back(d[i][j]);
						w[i + 1][j - 1].push_back(d[i][j]);
					}
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m - 1; j++) {
			// (i, j) (i + 1, j)
			if (g[i][j] == g[i][j + 1] && g[i][j] != '.') {
				// divan
				d[i][j] = t;
				d[i][j + 1] = t++;
				if (big(g[i][j])) {
					// down
					if (free(i + 1, j) && free(i + 1, j + 1)) {
						w[i + 1][j].push_back(d[i][j]);
						w[i + 1][j + 1].push_back(d[i][j]);
					}
				} else {
					// up
					if (free(i - 1, j) && free(i - 1, j + 1)) {
						w[i - 1][j].push_back(d[i][j]);
						w[i - 1][j + 1].push_back(d[i][j]);
					}
				}
			}
		}
	}

	gr.resize(t);
	color.resize(t);
	used.assign(t, 0);

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << "{";
	// 		for (auto e : w[i][j]) cout << e << " ";
	// 		cout << "} ";
	// 	}
	// 	cout << endl;
	// }

	for (int i = 0; i < n - 1; i++) { // n - 1
		for (int j = 0; j < m; j++) {
			for (int h = 0; h < w[i][j].size(); h++) {
				for (int o = 0; o < w[i][j].size(); o++) {
					if (o == h) continue;
					int a = w[i][j][h], b = w[i][j][o];
					gr[a].pb(b);
					gr[b].pb(a);
				}
			}
		}
	}

	// for (int i = 0; i < n; i++) { // n - 1
	// 	for (int j = 0; j < m; j++) {
	// 		cout << d[i][j] << " ";
	// 	}
	// 	cout << endl;
	// }

	for (int i = 0; i < t; i++) {
		sort(all(gr[i]));
		gr[i].resize(unique(all(gr[i])) - gr[i].begin());
		// cout << i << " : ";
		// for (auto e : gr[i]) cout << e << " ";
		// cout << endl;
	}
	

	for (int i = 0; i < t; i++) {
		if (!used[i]) {
			// cout << "here1" << endl;
			int a = 0, b = 0;
			dfs_zero(i);
			// cout << "a = " << a << endl;
			dfs_fill(i, i, 0);
			// cout << "a = " << a << endl;

			dfs_zero(i);
			a = dfs_count(i, i);
			// cout << "a = " << a << endl;
			dfs_zero(i);
			dfs_fill(i, i, 1);
			dfs_zero(i);
			b = dfs_count(i, i);
			dfs_zero(i);
			if (a > b) {
				dfs_fill(i, i, 0);
			} else {
				dfs_fill(i, i, 1);
			}
			// cout << "here2" << endl;
		}
	}
	// return 0;

	gn = g;
	int cnt = 0;
	for (int i = 0; i < n - 1; i++) {
		for (int j = 0; j < m; j++) {
			// (i, j) (i + 1, j)
			if (g[i][j] == g[i + 1][j] && g[i][j] != '.') {
				// divan
				
				gn[i][j] = '1' + ind(i, j);
				gn[i + 1][j] = '1' + ind(i, j);
				if (color[d[i][j]] == 1) {
					if (big(g[i][j])) {
						// right
						gn[i][j] = '1' + ind(i, j);
						gn[i + 1][j] = '1' + ind(i, j);
						if (free(i, j + 1) && free(i + 1, j + 1)) {
							gn[i][j + 1] = '1' + ind(i, j);
							gn[i + 1][j + 1] = '1' + ind(i, j);
							cnt++;
						}
					} else {
						// left
						gn[i][j] = '1' + ind(i, j - 1);
						gn[i + 1][j] = '1' + ind(i, j - 1);
						if (free(i, j - 1) && free(i + 1, j - 1)) {
							gn[i][j - 1] = '1' + ind(i, j - 1);
							gn[i + 1][j - 1] = '1' + ind(i, j - 1);
							cnt++;
						}
					}
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m - 1; j++) {
			// (i, j) (i + 1, j)
			if (g[i][j] == g[i][j + 1] && g[i][j] != '.') {
				// divan
				
				gn[i][j] = '1' + ind(i, j);
				gn[i][j + 1] = '1' + ind(i, j);
				if (color[d[i][j]] == 1) {
					if (big(g[i][j])) {
						// down
						gn[i][j] = '1' + ind(i, j);
						gn[i][j + 1] = '1' + ind(i, j);
						if (free(i + 1, j) && free(i + 1, j + 1)) {
							gn[i + 1][j] = '1' + ind(i, j);
							gn[i + 1][j + 1] = '1' + ind(i, j);
							cnt++;
						}
					} else {
						// up
						gn[i][j] = '1' + ind(i - 1, j);
						gn[i][j + 1] = '1' + ind(i - 1, j);
						if (free(i - 1, j) && free(i - 1, j + 1)) {
							gn[i - 1][j] = '1' + ind(i - 1, j);
							gn[i - 1][j + 1] = '1' + ind(i - 1, j);
							cnt++;
						}
					}
				}
			}
		}
	}
	cout << cnt << "\n";
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << gn[i][j];
		}
		cout << "\n";
	}

	return 0;
}