#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;
const int inf =  1e9;
int stupid(int n, int w, vector<pair<int,int>> a)
{
    vector<vector<int>> dp(n+1, vector<int> (w+1, -inf));
    dp[0][0] = 0;
    for(int i =0 ;i< n;++i)
    {
        for(int j = 0; j <= w; ++j)
        {
            dp[i+1][j] = max(dp[i+1][j], dp[i][j]);
            if(j + a[i].first <=w) dp[i+1][j+a[i].first] = max(dp[i+1][j+a[i].first], dp[i][j] + a[i].second);
        }
    }

    int ans= 0 ;
    for(int i= 0 ;i<=w;++i) ans =max(ans, dp[n][i]);
    return ans;
}
bool cmp(pair<pair<int,int>,int> a,pair<pair<int,int> , int> b)
{
    int x = a.first.first * b.first.second;
    int y = a.first.second* b.first.first;
    return x> y;
}
bool cmp2(pair<pair<int,int>,int> a,pair<pair<int,int>,int> b)
{
    return (a.first.first==b.first.first ? a.first.second < b.first.second : a.first.first > b.first.first);
}
bool cmp3(pair<pair<int,int>,int> a, pair<pair<int,int>,int> b)
{
    return (a.first.second ==b.first.second ? a.first.first > b.first.first : a.first.second< b.first.second);
}
bool cmp4(pair<pair<int,int>,int> a, pair<pair<int,int>,int> b)
{
    return (a.first.second ==b.first.second ? a.first.first > b.first.first : a.first.second> b.first.second);
}
#define all(v) (v).begin(),(v).end()
pair<int,vector<int>> kek(vector<pair<pair<int,int>,int>> a, int w)
{
    int tw= 0;
    int tans=0;
    vector<int> answer;
    for(int i =0 ; i< a.size();++i)
    {
        if(tw + a[i].first.second <=w)
        {
            answer.push_back(i);
            tw += a[i].first.second;
            tans += a[i].first.first;
        }
    }
    return {tans, answer};
}
pair<int, vector<int>> smart(int n, int w, vector<pair<int,int>> a)
{
    w*=3;
    for(int i =0 ; i< n;++i) a[i].first *=2;
    vector<pair<pair<int,int>,int>> govno;
    for(int i =0 ; i< n;++i)
    {
        govno.push_back({{a[i].second, a[i].first},  i});
    }
    sort(govno.begin(), govno.end(), cmp);
    int ansos= 0;
    int tw = 0;
    vector<int> ans;
    for(auto i : govno)
    {
        if(i.first.second + tw<=w)
        {
            ans.push_back(i.second);
            tw+=i.first.second;
            ansos += i.first.first;
        }
    }
    sort(govno.begin(), govno.end(), cmp2);
    tw= 0;
    int tans=0;
    vector<int> ttans;
    for(auto i : govno)
    {
        if(i.first.second + tw<=w)
        {
            ttans.push_back(i.second);
            tw+=i.first.second;
            tans += i.first.first;
        }
    }
    if(tans> ansos)
    {
        ansos = tans;
        ans = ttans;
    }
    ttans.clear();
    tw=0;
    tans=0;
    sort(govno.begin(), govno.end(), cmp3);
      for(auto i : govno)
    {
        if(i.first.second + tw<=w)
        {
            ttans.push_back(i.second);
            tw+=i.first.second;
            tans += i.first.first;
        }
    }
    if(tans> ansos)
    {
        ansos = tans;
        ans = ttans;
    }

    ttans.clear();
    tw=0;
    tans=0;
    sort(govno.begin(), govno.end(), cmp4);
      for(auto i : govno)
    {
        if(i.first.second + tw<=w)
        {
            ttans.push_back(i.second);
            tw+=i.first.second;
            tans += i.first.first;
        }
    }
    if(tans> ansos)
    {
        ansos = tans;
        ans = ttans;
    }

    sort(all(govno), cmp);
    for(int p = 0;p < 2;++p)
    {
        auto tkek = govno;
        tkek.clear();
        for(int i = p; i< n; i+=2)
        {
            tkek.push_back(govno[i]);
        }
        auto now = kek(tkek, w);
        if(now.first > ansos)
        {
            ansos = now.first;
            ans = now.second;
        }
    }
    mt19937 rnd(time(0) + 'l' + 'o' + 'l');
    for(int i = 0; i< 100;++i)
    {
        shuffle(all(govno), rnd);
        auto now = kek(govno, w);
        if(now.first > ansos)
        {
            ansos = now.first;
            ans = now.second;
        }
    }
    return {ansos, ans};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    mt19937 rnd(time(0));
    /*
    for(int test= 0;;++test)
    {
        int n = rnd() % 5+1;
        int w = rnd() % 15+1;
        vector<pair<int,int>> a(n);
        for(int i =0 ;i< n;++i) a[i].first = rnd() % w+1, a[i].second = rnd() % w+ 1;
        int x = smart(n,w,a).first;
        int y=  stupid(n,w,a);
        if(x<y)
        {
            cout<<"WA"<<endl;
            cout<<n<<' '<< w<< endl;
            for(auto i : a) cout<<i.first<<' '<< i.second<<endl;
            cout<<x<<' '<< y<<endl;
        return 0;
        }
        cout<<test<<endl;
    }*/
    int t;
    cin>>t;
    while(t--)
    {
        int n,w;
        cin>>n>>w;
        vector<pair<int,int>> a(n);
        for(int i =0 ;i < n;++i) cin>>a[i].first>>a[i].second;
        auto now = smart(n,w,a);
        cout<<now.second.size()<<'\n';
        for(int i : now.second) cout<<i + 1<<' ';
        cout<<'\n';
//        auto kek = smart(n,w, a);
 //       cout<<kek.first<<' '<< stupid(n,w,a) << endl;
    }

}
