#include <iostream>
#include <string>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

deque <string> ord;
string ans = "";

string convert(ll n, ll c)
{
    string w = "";
    while (n > 0)
    {
        w.push_back((char)('0' + (n % 2)));
        n /= 2;
    }
    while (w.size() < c) w.push_back('0');
    reverse(w.begin(), w.end());
    return w;
}

int main()
{
    ll n;
    cin >> n;
    if (n == 2)
    {
        cout << "0110";
        return 0;
    }
    ll m = 0;
    while (m + (1 << m) <= n) m++;
    m--;
    for (ll i = 0; i <= (1LL << (1LL << m)) - 1; i++) ord.push_back(convert(i, 1 << m));
    //for (string s : ord) cout << ": " << s << endl;
    bool ok = false;
    for (string s : ord) ans += s;
    for (ll i = 0; i < ord.size(); i++)
    {
        if (ok) break;
        for (ll j = i + 2; j < ord.size(); j++)
        {
            if (ans.size() >= (1LL << n))
            {
                ok = true;
                break;
            }
            ans += (ord[i] + ord[j]);
        }
    }
    cout << ans << endl;
    return 0;
}
