#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef __int128 i128;

vector <i128> fact(36);

void init() {
    fact[0] = 1;
    for (int i = 1; i <= 35; i++)
        fact[i] = fact[i - 1] * i;
}

i128 cnk(int n, int k) {
    i128 res = fact[n];
    res /= fact[k];
    res /= fact[n - k];
    return res;
}

int main() {
    init();
    int n, k;
    cin >> n >> k;
    set <vector <int>> s;
    for (int mask = 0; mask < (1ll << (n - 1)); mask++) {
        int cnt = 1;
        vector <int> arr;
        for (int i = 0; i < n - 1; i++) {
            if ((1ll << i) & mask) {
                cnt++;
            } else {
                arr.push_back(cnt);
                cnt = 1;
            }
        }
        arr.push_back(cnt);
        sort(arr.begin(), arr.end());
        s.insert(arr);
    }
    long long ans = 0;
    for (auto &arr : s) {
        vector <int> hm;
        int cnt = 1;
        for (int i = 1; i < (int)arr.size(); i++) {
            if (arr[i] == arr[i - 1]) {
                cnt++;
            } else {
                hm.push_back(cnt);
                cnt = 1;
            }
        }
        hm.push_back(cnt);
        i128 mult = 1;
        for (int x : hm)
            mult *= cnk(x + k - 1, k - 1);
        ans += mult;
    }
    cout << ans;
    return 0;
}