#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <unordered_set>
#include <tuple>
#include <queue>
#include <set>
#include <cstring>
#include <functional>
#include <random>
#include <chrono>
#include <cassert>
#include <iomanip>
// #include <ext/pb_ds/assoc_container.hpp>

#define ar array
#define all(arr) (arr).begin(), (arr).end()
#define range(i, n) for (int i=0; i < (n); ++i)
#define rall(arr) (arr).rbegin(), (arr).rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

// using namespace __gnu_pbds;
/*
typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
*/

const ll INF = 1e18;
const int INFi = 2e9;
const int maxN = 2e5 + 1;
const int md2 = 998244353;
const int md3 = 1e9 + 7;

double getTime() { return clock() / (double) CLOCKS_PER_SEC; }

void solve() {
    ll l, r;
    cin >> l >> r;
    auto get = [&](ll x) {
        vector<int> res;
        while (x) {
            res.push_back(x % 10);
            x /= 10;
        }
        return res;
    };
    auto a = get(l);
    auto b = get(r);
    while (a.size() < b.size()) a.push_back(0);
    reverse(all(a));
    reverse(all(b));
    int ans = 0;
    ll cans = 0;
    auto check = [&](vector<int> &cc) {
        int c = 0;
        int mx = 0;
        range(i, (int) cc.size()) {
            if (!i || cc[i] != cc[i - 1]) {
                c = 0;
            }
            c++;
        }
    };
    int j = -1;
    range(i, (int) a.size()) {
        if (a[i] != b[i]) {
            j = i;
            ans = max(ans, (int) a.size() - j - 1);
            break;
        }
    }
    if (j != -1) {
        if (a[j] + 2 <= b[j]) {
            ans = max(ans, (int) a.size() - j);
        }
    } else {
        int mx = 0;
        int cnt = 0;
        range(i, j) {
            if (!i || a[i] != a[i - 1]) cnt = 0;
            cnt++;
            mx = max(mx, cnt);
        }
        cout << mx << ' ';
        cout << 1 << "\n";
        return;
    }
    for (int num = 0; num <= 9; ++num) {
        int cnt = 0;
        for (int e = j - 1; e >= 0; --e) {
            if (b[e] == num) cnt++;
            else break;
        }
        bool bcheck = true;
        bool acheck = true;
        for (int i = j; i < (int) a.size(); ++i) {
            if (acheck) {
                if (a[i] > num) break;
                if (a[i] < num) acheck = false;
            }
            if (bcheck) {
                if (b[i] < num) break;
                if (b[i] > num) bcheck = false;
            }
            cnt++;
        }
        ans = max(ans, cnt);
    }
    cout << ans << ' ';
    {
        int mx = 0;
        int cnt = 0;
        range(i, j) {
            if (!i || a[i] != a[i - 1]) cnt = 0;
            cnt++;
            mx = max(mx, cnt);
        }
        if (mx == ans) {
            cout << r - l + 1 << '\n';
            return;
        }
    }
    vector<ll> st10(16);
    st10[0] = 1;
    range(i, 15) st10[i + 1] = st10[i] * 10;
    for (int start = 0; start + ans <= (int) a.size(); ++start) {
        if (start + ans <= j) continue;
        if (start == j + 1) continue;
        for (int num = 0; num <= 9; ++num) {
            bool bcheck = true;
            bool acheck = true;
            bool bad = false;
            for (int e = start; e < j; ++e) {
                if (a[e] != num) {
                    bad = true;
                    break;
                }
            }
            if (bad) continue;
            for (int e = j; e < start + ans; ++e) {
                if (acheck) {
                    if (a[e] > num) {
                        bad = true;
                        break;
                    }
                    if (a[e] < num) acheck = false;
                }
                if (bcheck) {
                    if (b[e] < num) {
                        bad = true;
                        break;
                    }
                    if (b[e] > num) bcheck = false;
                }
            }
            if (bad) continue;
            ll R, L;
            if (bcheck) {
                R = r % st10[(int) a.size() - start - ans];
            } else {
                R = st10[(int) a.size() - start - ans] - 1;
            }
            if (acheck) {
                L = l % st10[(int) a.size() - start - ans];
            } else {
                L = 0;
            }
            cans += R - L + 1;
        }
    }
    if (j + 1 + ans == a.size()) {
        for (int X = a[j]; X <= b[j]; ++X) {
            for (int num = 0; num <= 9; ++num) {
                bool bcheck = X == b[j];
                bool acheck = X == a[j];
                int cnt = 0;
                for (int i = j + 1; i < (int) a.size(); ++i) {
                    if (acheck) {
                        if (a[i] > num) break;
                        if (a[i] < num) acheck = false;
                    }
                    if (bcheck) {
                        if (b[i] < num) break;
                        if (b[i] > num) bcheck = false;
                    }
                    cnt++;
                }
                if (cnt == ans) cans++;
            }
        }
        if (ans * 2 <= a.size()) {
            for (int X = a[j]; X <= b[j]; ++X) {
                bool bad = false;
                for (int e = j - ans + 1; e <= j; ++e) {
                    if (X < a[e] || X > b[e]) {
                        bad = true;
                        break;
                    }
                }
                if (bad) continue;
                for (int num = 0; num <= 9; ++num) {
                    bool bcheck = (X == b[j]);
                    bool acheck = (X == a[j]);
                    int cnt = 0;
                    for (int i = j + 1; i < (int) a.size(); ++i) {
                        if (acheck) {
                            if (a[i] > num) break;
                            if (a[i] < num) acheck = false;
                        }
                        if (bcheck) {
                            if (b[i] < num) break;
                            if (b[i] > num) bcheck = false;
                        }
                        cnt++;
                    }
                    if (cnt == ans) cans--;
                }
            }
        }
    }
    cout << cans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    // cout << setprecision(15) << fixed;
    int tests = 1;
    cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}