#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

typedef pair <int, int> pii;

struct vec {
  ll x, y;
  void read() {
    ll a, b;
    cin >> a >> b;
    x = a, y = b;
  }
  ll operator*(vec p) {  // скалярное произведение
    return x * p.x + y * p.y;
  }
  ll operator%(vec p) {  // "векторное" произведение
    return x * p.y - y * p.x;
  }
  vec operator-(vec p) {
    vec a = {x - p.x, y - p.y};
    return a;
  }
  static int sig(ll val) {
    if (val > 0)
      return 1;
    if (val == 0)
      return 0;
    return -1;
  }
  static bool intersect_segment_segment(vec a, vec b, vec c, vec d) {
    int flag1 = sig((a - b) % (c - b)) * sig((a - b) % (d - b));
    int flag2 = sig((c - d) % (a - d)) * sig((c - d) % (b - d));
    return (flag1 < 0 && flag2 < 0);
  }
};

int main() {
    int n;
    cin >> n;
    vector <vec> p(n);
    for (int i = 0; i < n; i++)
        p[i].read();
    int cnt = -1;
    {
        vector <pii> e;
        vector <bool> used(n);
        bool flag = true;
        while (flag) {
            flag = false;
            cnt++;
            for (int i = 0; i < n; i++) {
                if (used[i])
                    continue;
                for (int j = 0; j < n; j++) {
                    if (i == j)
                        continue;
                    if (used[j])
                        continue;
                    bool tmp = true;
                    for (auto &now : e) {
                        int inda = now.first, indb = now.second;
                        if ((inda == i && indb == j) || (inda == j && indb == i)) {
                            tmp = false;
                            break;
                        }
                        if (vec::intersect_segment_segment(p[inda], p[indb], p[i], p[j])) {
                            tmp = false;
                            break;
                        }
                    }
                    if (tmp) {
                        e.push_back({i, j});
                        flag = true;
                        break;
                    }
                }
                if (flag)
                    break;
                used[i] = true;
            }
        }
    }
    vector <pii> e;
    if (cnt % 2 == 0) {
        cout << 2 << endl;
        int i, j;
        cin >> i >> j;
        e.push_back({i - 1, j - 1});
    }
    vector <bool> used(n);
    bool flag = true;
    while (flag) {
        flag = false;
        cnt++;
        for (int i = 0; i < n; i++) {
            if (used[i])
                continue;
            for (int j = 0; j < n; j++) {
                if (i == j)
                    continue;
                if (used[j])
                    continue;
                bool tmp = true;
                for (auto &now : e) {
                    int inda = now.first, indb = now.second;
                    if ((inda == i && indb == j) || (inda == j && indb == i)) {
                        tmp = false;
                        break;
                    }
                    if (vec::intersect_segment_segment(p[inda], p[indb], p[i], p[j])) {
                        tmp = false;
                        break;
                    }
                }
                if (tmp) {
                    e.push_back({i, j});
                    cout << i + 1 << ' ' << j + 1 << endl;
                    flag = true;
                    break;
                }
            }
            if (flag)
                break;
            used[i] = true;
        }
        int i, j;
        cin >> i >> j;
        e.push_back({i - 1, j - 1});
        if (!i)
            break;
    }
    return 0;
}

