//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("fma,avx,avx2")
#include <iostream>
#include <random>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
//#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

mt19937 rnd(6547389847627);

typedef long long ll;

#define int long long
#define ld double
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define sqr(a) (a) * (a)
#define debug(x) cout << #x << ": " << x << '\n'

template<class t, class u>
void amax(t &a, u b) { if (a < b) a = b; }

template<class t, class u>
void amin(t &a, u b) { if (b < a) a = b; }

template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

#define one(x) memset(x, -1, sizeof(x))
#define zero(x) memset(x, 0, sizeof(x))

void solve() {
    int n;
    cin >> n;
    vi a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        vector<int> ca = a;
        vector<int> cb = b;
        cb[i] = 0;

        for (int l = 0; l < n; ++l) {
            for (int r = 0; r < n; ++r) {
                if (l == r) {
                    continue;
                }
                int d1 = min(ca[l], cb[r]);
                ca[l] -= d1;
                cb[r] -= d1;
            }
        }
        int c = 0;
        for (int i = 0; i < n; ++i) {
            //cout <<ca[i]<<" "<<cb[i]<<"\n";

            c += (cb[i] > 0);
        }
        //cout <<"\n";
        if (c < 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";

}


void solve2() {
    int n;
    cin >> n;
    vi a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vi c(n);
    int sumb = 0;
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        sumb += b[i];
        c[i] = a[i] + b[i];
    }
    sort(all(c));
    vi s(n + 1);
    for (int i = 1; i <= n; i++) {
        s[i] = s[i - 1] + c[i - 1];
    }
    bool ans = false;
    for (int i = 0; i < n; i++) {
        int sum = -sumb + b[i];
        auto it = upper_bound(all(c), sumb - b[i]) - c.begin();
        sum += s[it];
        sum += (n - it) * (sumb - b[i]);
/*        for (int j = 0; j < n; j++) {
            sum += min(a[j] + b[j], sumb - b[i]);

        }*/
        sum += -min(a[i] + b[i], sumb - b[i]) + min(a[i], sumb - b[i]);
        if (sum >= sumb - b[i]) ans = true;
    }

    cout << (ans ? "YES" : "NO") << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve2();
    }
    return 0;
}