#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const int INF = 1e9 + 13;
const int M = 1e9 + 7;
const int N = 1e6 + 13;
const int K = 2013;
const int D = 4;

int di[] = {0, 1, 0, -1};
int dj[] = {1, 0, -1, 0};
/*

*/

int n, m;

bool isin(int i, int j) {
    return (0 <= i && i < n && 0 <= j && j < m);
}

vector<int> g1[N];
bool used1[N];
int col1[N];

bool is[N];

vector<int> g2[N];
int col2[N];
bool used2[N];

string s[K];
int a[K][K];
int res[K][K];
vector<int> b[K][K];

vector<pair<pii, int>> sf;
vector<pii> sf2;

void dfs1(int v, int cl) {
//    cout << v << ' ' << cl << endl;
    used1[v] = true;
    col1[v] = cl;

    for(auto u : g1[v])
        if(!used1[u])
            dfs1(u, cl ^ 1);
}

void dfs2(int v) {
    used2[v] = true;
    set<int> st;
    for(auto u : g2[v]) {
        if(used2[u])
            st.insert(col2[u]);
    }
    for(int i = 0; ; i++) {
        if(st.count(i) == 0) {
            col2[v] = i;
            break;
        }
    }

    for(auto u : g2[v])
        if(!used2[u])
            dfs2(u);
}

int main() {

    cin >> n >> m;

    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }

    int cur = 0;

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            a[i][j] = -1;
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(a[i][j] == -1 && s[i][j] != '.') {
                a[i][j] = cur;
                is[cur] = true;
                for(int d = 0; d < D; d++) {
                    int i1 = i + di[d];
                    int j1 = j + dj[d];

                    if(isin(i1, j1) && s[i1][j1] == s[i][j]) {
                        a[i1][j1] = cur;
                        int k;
                        if(d == 0 && 'a' <= s[i][j] && s[i][j] <= 'z')
                            k = 3;
                        else if(d == 0)
                            k = 1;
                        else if('a' <= s[i][j] && s[i][j] <= 'z')
                            k = 2;
                        else
                            k = 0;

                        sf.emplace_back(mp(i, j), k);
                        sf2.emplace_back(i1, j1);

                        int i2 = i + di[k];
                        int j2 = j + dj[k];
                        b[i2][j2].push_back(cur);

                        if(s[i2][j2] != '.') {
                            is[cur] = false;
                        }

                        i2 = i1 + di[k];
                        j2 = j1 + dj[k];
                        b[i2][j2].push_back(cur);

                        if(s[i2][j2] != '.') {
                            is[cur] = false;
                        }
                    }
                }
                cur++;
            }
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            for(int k = 0; k < b[i][j].size(); k++) if(is[b[i][j][k]]) {
                for(int l = 0; l < k; l++) if(is[b[i][j][l]]) {
                    g1[b[i][j][k]].push_back(b[i][j][l]);
                    g1[b[i][j][l]].push_back(b[i][j][k]);
                }
            }
        }
    }

    for(int i = 0; i < cur; i++) {
        if(is[i] && g1[i].size() < 2 && !used1[i]) {
            dfs1(i, 1);
        }
    }

    for(int i = 0; i < cur; i++) {
        if(is[i] && !used1[i]) {
            dfs1(i, 1);
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) if(s[i][j] == '.') {
            for(auto x : b[i][j])
                if(col1[x] == 1) {
                    a[i][j] = x;
                }
        }
    }

//    for(int i = 0; i < cur; i++) {
//        cout << sf[i].f.f << ' ' << sf[i].f.s << ' ' << sf[i].s << ' '
//        << col1[i] << endl;
//    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) if(a[i][j] != -1) {
            for(int d = 0; d < D; d++) {
                int i1 = i + di[d];
                int j1 = j + dj[d];

                if(!isin(i1, j1))
                    continue;

                if(a[i1][j1] != -1) {
                    g2[a[i][j]].push_back(a[i1][j1]);
                    g2[a[i1][j1]].push_back(a[i][j]);
                }
            }
        }
    }

    for(int i = 0; i < cur; i++)
        col2[i] = -1;

    for(int i = 0; i < cur; i++)
        if(!used2[i])
            dfs2(i);

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) if(s[i][j] == '.'){
            res[i][j] = -1;
            for(auto x : b[i][j])
                if(col1[x] == 1)
                    res[i][j] = col2[x];
        } else {
            res[i][j] = col2[a[i][j]];
        }
    }

//    for(int ind = 0; ind < cur; ind++) {
//        int i = sf[ind].f.f;
//        int j = sf[ind].f.s;
//        int i1 = sf2[ind].f;
//        int j1 = sf2[ind].s;
//
//        int d = sf[ind].s;
//
//        a[i][j] = col2[ind];
//        a[i1][j1] = col2[ind];
//
//        int i2 = i + di[d];
//        int j2 = j + dj[d];
//
//        a[i2][j2] = col2[d];
//
//        i2 = i1 + di[d];
//        j2 = j1 + dj[d];
//
//        a[i2][j2] = col2[d];
//    }

    int ans = 0;
    for(int i = 0; i < cur; i++)
        ans += col1[i];

    cout << ans << endl;

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << (res[i][j] == -1 ? '.' : char(res[i][j] + '0'));
        }
        cout << endl;
    }
}
