#include <bits/stdc++.h>
#define IOS cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#define all(a) a.begin(), a.end()
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;

const int MAXN = 1e5 + 7;
const int MOD1 = 1e9 + 7;
const ll MOD2 = 4294967296;
const int P1 = 17239;
const int P2 = 23917;
const ll INF = 1e12;
const long double PI = acos(-1.0);

void solve() {
	int n; cin >> n;
	vector<ll> a(n), b(n);
	for (auto &i : a) cin >> i;
	for (auto &i : b) cin >> i;
	int id = 0;
	ll s_a = 0, s_b = 0;
	for(int i = 0; i <n; i++) {
		if (b[i] > b[id]) {
			id = i;
		} else if (b[i] == b[id]) {
			if (a[i] > a[id]) {
				id = i;
			}
		}
		s_a += a[i];
		s_b += b[i];
	}
//	if (s_a < s_b - b[id]) {
//		cout << "NO\n";
//		return;
//	}
	for (int i = 0; i < n; i++) {
		if (i != id && s_a - a[i] < b[i]) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
}

int main() {
	int t; cin >> t;
	while (t--) solve();
}
