#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <tuple>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

using namespace std;

int sum(int i, vector<pair<int, int>>& a, vector<int>& prefSum) {
    auto it = upper_bound(a.begin(), a.end(), make_pair(i, 2000000000));
    int p = (it - a.begin());
    p--;
    if (p < 0) {
        return 0;
    }
    return prefSum[p] - max(a[p].second - i, 0);
}

void solve() {
    int ans = 0;
    int n, m, s;
    cin >> n >> m >> s;
    set<int> st;
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        st.insert(x);
    }
    vector<pair<int, int>> a;
    int lst = -1;
    for (auto it = st.begin(); it != st.end(); it++) {
        auto it1 = it;
        it1++;
        auto it0 = it;
        while (it1 != st.end() && *it1 == *it0 + 1) {
            it0++;
            it1++;
        }
        a.push_back({*it, *it0});
        it = it0;
    }
    vector<int> prefSum(a.size());
    prefSum[0] = a[0].second - a[0].first + 1;
    for (int i = 1; i < a.size(); ++i) {
        prefSum[i] = prefSum[i - 1] + a[i].second - a[i].first + 1;
    }
    for (int i = 0; i < a.size(); ++i) {
        int l0 = a[i].first;
        int r0 = a[i].second;
        int l = 0;
        if (i) {
            l = a[i - 1].second;
        }
        int r = l0 + 1;

        int l_sum = 0;
        if (i) {
            l_sum = prefSum[i - 1];
        }
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int rght = mid + m - 1;
            int r_sum = sum(rght, a, prefSum);
            if (r_sum - l_sum >= m - s) {
                r = mid;
            }
            else {
                l = mid;
            }
        }

        ans += l0 - r + 1;
    }
    int l = a.back().first;
    int r = a.back().second;
    for (int i = l + 1; i <= r; ++i) {
        int tmp = r - i + 1;
        if (tmp + s >= m && i + m - 1 <= n) {
            ++ans;
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
