#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

struct Point {
    ld x, y;
};

istream& operator >> (istream& f, Point& a) {
    f >> a.x >> a.y;
    return f;
}

ostream& operator << (ostream& f, Point& a) {
    f << a.x << ' ' << a.y;
    return f;
}

ostream& operator << (ostream& f, vector<ll>& a) {
    for (auto i : a) {
        f << i << ' ';
    }
    return f;
}

ostream& operator << (ostream& f, vector<int>& a) {
    for (auto i : a) {
        f << i << ' ';
    }
    return f;
}

ll min(ll a, int b) {
    return min(a, ll(b));
}

ll min(int a, ll b) {
    return min(ll(a),(b));
}




signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t1, v1, t2, v2;
    int k = 0;
    cin >> t1 >> v1 >> t2 >> v2;
    if (t2 < 0 && v2 >= 10) {
        cout << "A storm warning for tomorrow! Be careful and stay home if possible!\n";
        k++;
        return 0;
    }
    if (t2 < t1) {
        cout << "MCHS warns! Low temperature is expected tomorrow.\n";
        k++;
        return 0;
    }
    if (v2 > v1) {
        cout << "MCHS warns! Strong wind is expected tomorrow.";
        k++;
        return 0;
    }
    if (k == 0) {
        cout << "No message";
    }
}