#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

struct Point {
    ld x, y;
};

istream& operator >> (istream& f, Point& a) {
    f >> a.x >> a.y;
    return f;
}

ostream& operator << (ostream& f, Point& a) {
    f << a.x << ' ' << a.y;
    return f;
}

ostream& operator << (ostream& f, vector<ll>& a) {
    for (auto i : a) {
        f << i << ' ';
    }
    return f;
}


ll min(ll a, int b) {
    return min(a, ll(b));
}

ll min(int a, ll b) {
    return min(ll(a),(b));
}



signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    vector<ll> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    a.push_back(1);
    sort(a.begin(), a.end());
    
    int h = m - s;
    m++;

    int k = 0;

    for (int i = 2; i <= h; ++i) {
        k += a[i] - a[i - 1] - 1;
    }
    ll ans = 0;
    for (int i = 2; i + h - 1 < m; ++i) {
        int y = h - k;
        if (y > 0 && y < m) {
            int g = a[i - 1] - a[i - 2];
            ans += min(g, y);
            ans += y;
        }
        k -= a[i] - a[i - 1] - 1;
        k += a[i + h - 1] - a[i + h - 2] - 1;
    }
    cout << ans;
}