#include<bits/stdc++.h>

using namespace std;
//#define int long long
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1;//(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

bool matr[309][309];

struct Point {
    int x, y;
    Point() {};
    Point(int _x, int _y) {
        x = _x;
        y = _y;
    }

    Point (Point a, Point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    int operator * (Point oth) {
        return x * oth.y - y * oth.x;
    }

    bool operator == (Point oth) {
        return oth.x == x && oth.y == y;
    }
};

inline int sgn(int x) {
    if (x == 0) return 0;
    if (x < 0) return -1;
    return 1;
}

inline bool inters(Point a, Point b, Point c, Point d) {
    if (a == c || a == d || b == c || b == d) return 0;
    if (sgn(Point(a, c) * Point(a, b)) == sgn(Point(a, d) * Point(a, b)) || sgn(Point(b, c) * Point(b, a)) == sgn(Point(b, d) * Point(b, a)) ||
        sgn(Point(d, a) * Point(d, c)) == sgn(Point(d, b) * Point(d, c)) || sgn(Point(c, a) * Point(c, d)) == sgn(Point(c, b) * Point(c, d))) {
            return 0;
        }

        return 1;
}

main() {
#ifdef karpovich
    //freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Point> a(n + 1);
    for (int i = 1; i <= n; i ++) cin >> a[i].x >> a[i].y;

    set<pii> used;
    int cnt = 0;
    bool run = 1;
    while (run) {
        run = 0;
        for (int i = 1; i <= n; i ++) {
            for (int j = i + 1; j <= n; j ++) {
                if (matr[i][j]) continue;
                bool ok = 1;
                for (auto u : used) {
                    if (inters(a[u.x], a[u.y], a[i], a[j])) {
                        ok = 0;
                        break;
                    }
                }

                if (ok) {
                    run = 1;
                    used.insert({i, j});
                    matr[i][j] = 1;
                    cnt++;
                }
            }
        }
    }

    for (int i =1; i <=n ; i++) {
        for (int j = i + 1; j <= n; j++) matr[i][j] = 0;
    }

    used.clear();
    if (cnt % 2 == 0) {
        cout << 2 << endl;
        int a, b;
        cin >> a >> b;

        if (a > b) swap(a, b);
        used.insert({a, b});
        matr[a][b] = 1;
    }

    else {
        cout << 1 << endl;
    }

    while (true) {
        run = 0;
        for (int i = 1; i <= n && !run; i ++) {
            for (int j = i + 1; j <= n && !run; j ++) {
                if (matr[i][j]) continue;
                bool ok = 1;
                for (auto u : used) {
                    if (inters(a[u.x], a[u.y], a[i], a[j])) {
                        ok = 0;
                        break;
                    }
                }

                if (ok) {
                    run = 1;
                    used.insert({i, j});
                    matr[i][j] = 1;
                    cout << i << ' ' << j << endl;
                }
            }
        }

        int a, b;
        cin >> a >> b;

        if (a == 0) break;
        if (a > b) swap(a, b);
        used.insert({a, b});
        matr[a][b] = 1;
    }

    return 0;
}

