//_

#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define _ << " " <<
#define ff first
#define ss second
#define pb push_back

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

string rev(string &s) {
    string ans;
    for (int i = 0; i < s.length(); ++i) {
        if (s[i] == '0') ans.pb('1');
        else ans.pb('0');
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;

    if (n == 1) {
        cout << "01";
        return;
    } else if (n == 2) {
        cout << "0010";
        return;
    }

    vector<string> dp(n + 1);
    dp[1] = "01";
    dp[2] = "0010";

    string s;
    for (int i = 3; i <= n; ++i) {
        if (i % 2 == 0) {
            s = dp[i - 1];
            reverse(s.begin(), s.end());

            dp[i] = dp[i - 1] + s;
        } else {
            s = rev(dp[i - 1]);
            dp[i] = dp[i - 1] + s;
        }
    }

    cout << dp[n];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}
