#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define pb push_back
#define F first
#define S second
#define ll long long
#define ull unsigned long long
#define ld long double
#define endl '\n'
#define TIME 1.0*clock()/CLOCKS_PER_SEC
#define pii pair < int , int >
#define Endl '\n'

#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

template <typename T> using ordered_set = tree <T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int mod = 1e9 + 7;
const int FFTM = 998244353;

const int sx[4] = {0 , 1 , -1 , 0};
const int sy[4] = {1 , 0 , 0 , -1};
const int rx[8] = {1, -1, 0, 0, 1, 1, -1, -1};
const int ry[8] = {0, 0, 1, -1, 1, -1, 1, -1};
const int kx[8] = {1, 1, -1, -1, 2, 2, -2, -2};
const int ky[8] = {2, -2, 2, -2, 1, -1, 1, -1};

typedef cc_hash_table< int, int, hash<int>, equal_to<int>, direct_mask_range_hashing<int>, hash_standard_resize_policy<hash_exponential_size_policy<>, hash_load_check_resize_trigger<true>, true>> ht;

bool les(string &a, string &b){
    if (a.size() < b.size())return 1;
    if (a.size() > b.size())return 0;
    for (int i = 0;i < a.size(); ++i){
        if (a[i] < b[i])return 1;
        else if (a[i] > b[i])return 0;
    }
    return 1;
}

bool big(string &a, string &b){
    if (a.size() > b.size())return 1;
    if (a.size() < b.size())return 0;
    for (int i = 0;i < a.size(); ++i){
        if (a[i] > b[i])return 1;
        else if (a[i] < b[i])return 0;
    }
    return 1;
}

void solve(){
    string a, b;
    cin >> a >> b;
    
    string ans = "";
    
    int n = (int)a.size();
    int m = (int)b.size();
    
    bool ok = 0;
    int kol = 0;
    
    for (int i = 1; i <= 9; ++i){
        for (int j = 0;j < m; ++j){
            ans += char('0' + i);
        }
        if (les(ans, b) && big(ans, a)){
            ok = 1;
            kol++;
        }
        ans.clear();
    }
    if (ok){
        cout << m << " " << kol << endl;
        return;
    }
    
    set < string > all;
    
    for (int i = 0; i <= 9; ++i){
        for (int j = 0;j < m - 1; ++j){
            ans += char('0' + i);
        }
        if (i != 0 && les(ans, b) && big(ans, a))all.insert(ans);
        for (int c = 0;c <= 9; ++c){
            if (c == 0 && i != 0){
                ans += char('0' + c);
                if (les(ans, b) && big(ans, a)){
                    all.insert(ans);
                }
                ans.pop_back();
            }else if (i == 0 && c == 0){
            }else{
                ans += char('0' + c);
                if (i != 0 && les(ans, b) && big(ans, a)){
                    all.insert(ans);
                }
                reverse(ans.begin(), ans.end());
                if (les(ans, b) && big(ans, a)){
                    all.insert(ans);
                }
                reverse(ans.begin(), ans.end());
                ans.pop_back();
            }
        }
        ans.clear();
    }
    cout << m - 1 << " " << all.size() << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while(t --> 0)solve();
    return 0;
}
