#include <bits/stdc++.h>

using namespace std;

vector<int> a;
vector<int> t;

void Build_Tree(int v, int l, int r)
{
	if(l == r - 1)
	{
		t[v] = a[l];
		return;
	}
	int m = (l + r) / 2;
	Build_Tree(v * 2, l, m);
	Build_Tree(v * 2 + 1, m, r);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

long long RSQ(int v, int tl, int tr, int l, int r)
{
	if(l >= tr || r <= tl)
	{
		return 0;
	}
	if(tl >= l && tr <= r)
	{
		return t[v];
	}
	int m = (tl + tr) / 2;
	return RSQ(v * 2, tl, m, l, r) + RSQ(v * 2 + 1, m, tr, l, r);
}

int main()
{
	long long n, m, s, x, counter = 0, ss;
	cin >> n >> m >> s;
	a.assign(n + 1, 0);
	for(int i = 0; i < m; ++i)
	{
		cin >> x;
		a[x] = 1;
	}
	t.assign(m * 4 + 1, 0);
	Build_Tree(1, 1, (int)a.size());
	for(int i = 1; i <= n - m + 1; ++i)
	{
		ss = RSQ(1, 1, (int)a.size(), i, i + m);
		if(m - ss <= s)
		{
			++counter;
		}
	}
	cout << counter << endl;
	return 0;
}
///evomokamaqe
