#pragma GCC optimize("O2,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2")
#include<bits/stdc++.h>
#define all(x) begin(x), end(x)
using namespace std;
using ll = long long;
const int maxn = 1<<18, mod = 998244353;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
array<ll, 2> dp[20][10][20];
array<ll, 2> merge(array<ll, 2> a, array<ll, 2> b) {
    if(a[0] < b[0]) swap(a, b);
    if(a[0] == b[0]) a[1] += b[1];
    return a;
}
array<ll, 2> inc(array<ll, 2> a) {
    return {a[0]+1, a[1]};
}
ll p10[19];
array<ll, 2> solve(int pos, int lst, int streak) {
    if(pos == 0) return {streak, 1};
    if(dp[pos][lst][streak][0] != -1) return dp[pos][lst][streak];
    auto &ans = dp[pos][lst][streak];
    for(int d= 0; d < 10; d++) {
        auto t= solve(pos-1, d, 1 + streak*(lst==d));
        if(t[0] <= streak) t = {streak, p10[pos-1]};
        ans = merge(ans, t);
    }
    //cout << pos << " " << lst << " " << streak << " " << ans[0] << endl;
    return ans;
}
array<ll, 2> cnt(ll pos, ll cur, ll lst, ll mx) {
    auto t = solve(pos, lst, cur);
    //cout << pos << " " << cur << " " << lst << " " << mx << " " << t[0] << " " << t[1] << endl;
    if(t[0] <= mx) t = {mx, p10[pos]};
    //cout << pos << " " << cur << " " << lst << " " << mx << " " << t[0] << " " << t[1] << endl;
    return t;
}
int main() {
    cin.tie(0)->sync_with_stdio(0);
    p10[0] = 1;
    for(int i = 1; i < 19; i++) p10[i] = p10[i-1]*10ll;
    for(int i = 0; i < 20; i++)
        for(int j = 0; j < 10; j++)
            for(int k = 0; k < 20; k++)
                    dp[i][j][k] = {-1, 0};
    int t;
    cin >> t;
    while(t--) {
        string l, r;
        cin >> l >> r;
        reverse(all(l));
        reverse(all(r));
        while(l.size() < r.size()) l += "0";
        while(r.size() < l.size()) r += "0";
        reverse(all(r));
        reverse(all(l));
        int eq = 1;
        array<ll, 2> ans {0, 0};
        int ma = 0, ca = 0, mb = 0, cb = 0;
        char la = 0, lb = 0;
        int ahnz = 0, bhnz = 0;
        //cout << l << " " << r << endl;
        for(int i = 0; i < r.size(); i++) {
            for(int d = 0; d < 10; d++) {
                if(eq) {
                    if(l[i]-'0' < d && d < r[i]-'0') {
                        //cout << i << " - " << d << endl;
                        int na = ca*(la-'0' == d) + 1;
                        ans = merge(ans, cnt(r.size() - i - 1, na, d, max(na, ma)));
                    }
                } else {
                    if(l[i]-'0' < d) {
                        //cout << i << " -- " << d << endl;
                        int na = ca*(la-'0' == d) + 1;
                        na *= ahnz || d;
                        ans = merge(ans, cnt(r.size() - i - 1, na, d, max(na, ma)));
                    }
                    if(d < r[i]-'0') {
                        //cout << i << " _ " << d << endl;
                        int nb = cb*(lb-'0' == d) + 1;
                        nb *= bhnz || d;
                        ans = merge(ans, cnt(r.size() - i - 1, nb, d, max(nb, mb)));
                    }
                }
            }
            if(i < r.size()) {
                ahnz |= l[i] > '0';
                bhnz |= r[i] > '0';
                eq &= l[i] == r[i];
                ca = ca*(l[i] == la) + 1;
                ma = max(ma, ca*ahnz);
                cb = cb*(r[i] == lb) + 1;
                mb = max(mb, cb*bhnz);
                la = l[i];
                lb = r[i];
            }
            //cout << i << " " << ans[0] << " " << ans[1] << endl;
        }
        ans = merge(ans, cnt(0, ca, la-'0', ma));
        if(l != r) ans = merge(ans, cnt(0, cb, lb-'0', mb));
        cout << ans[0] << " " << ans[1] << endl;
    }
}
