#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 2e5 + 5;

int a[N];
int b[N];
int t[4 * N];
int prom[4 * N];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = b[tl];
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

void push(int v, int tl, int tr) {
    if (prom[v] != -1) {
        t[v] = prom[v];
        if (tl != tr) {
            prom[v * 2] = prom[v];
            prom[v * 2 + 1] = prom[v];
        }
        prom[v] = -1;
    }
}

void update(int v, int tl, int tr, int l, int r, int cur) {
    if (l > r) return;
    push(v, tl, tr);
    if (tl == l && tr == r) {
        prom[v] = cur;
        return;
    }
    int m = (tl + tr) / 2;
    update(v * 2, tl, m, l, min(m, r), cur);
    update(v * 2 + 1, m + 1, tr, max(m + 1, l), r, cur);
    push(v * 2, tl, m);
    push(v * 2 + 1, m + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int sum(int v, int tl, int tr, int l, int r) {
//    cout << l << ' ' << r << ' ' << tl << ' ' << tr << '\n';
    if (l > r) return 0;
    push(v, tl, tr);
    if (tl == l && tr == r) return t[v];
    int m = (tl + tr) / 2;
    return sum(v * 2, tl, m, l, min(r, m)) + sum(v * 2 + 1, m + 1, tr, max(m + 1, l), r);
}

int get(int v, int tl, int tr, int s) {
    push(v, tl, tr);
    if (tl == tr) return tl;
    int m = (tl + tr) / 2;
    push(v * 2, tl, m);
    push(v * 2 + 1, m + 1, tr);
    if (t[v * 2] >= s) get(v * 2, tl, m, s);
    else get(v * 2 + 1, m + 1, tr, s - t[v * 2]);
}

void solve () {
    int n;
    cin >> n;
    for (int i = 0; i <= 4 * n; i ++) prom[i] = -1;
    for (int i = 1; i <= n; i ++) cin >> b[i];
    for (int i = 1; i <= n; i ++) cin >> a[i];
    bool ok = false;
    int x = *max_element(a + 1, a + n + 1);
    int poss = 0;
    for (int i = 1; i <= n; i ++) {
        if (a[i] == x && b[i] > b[poss]) poss = i;
    }
//    cout << poss << ' ';
    build(1, 1, n);
    for (int i = 1; i <= n; i ++) {
        if (!a[i]) continue;
        if (i == poss) {ok = true; continue;}
//        cout << i << "| ";
        for (int j = 1; j <= n; j ++) {
//            cout << j << ' ' << sum(1, 1, n, j, j) << '\n';
        }
        int s = a[i] + sum(1, 1, n, i, i);
        int psi = get(1, 1, n, s - b[i]);
        if (psi < i) s = a[i];
//        cout << t[1] << ' ' << s << '\n';
        if (t[1] < s) {
            s -= t[1];
            for (int j = 1; j <= n; j ++) if (j != i)s += a[j];
            if (s == 1) {cout << "YES\n"; return;}
            else {cout << "NO\n"; return;}
        }
        int pos = get(1, 1, n, s);
        int s1 = sum(1, 1, n, 1, pos);
//        cout << i << ' ' << pos << ' ' << s1 << ' ' << s << '\n';
        update(1, 1, n, pos, pos, (s1 - s));
        update(1, 1, n, 1, i - 1, 0);
        update(1, 1, n, i + 1, pos - 1, 0);
        a[i] = 0;
    }
    cout << "YES\n";
}

/**
1
3
1 2 1
2 1 1
**/

main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t --) {
        solve();
    }
}
