#include <bits/stdc++.h>
using namespace std;

int n, m, k;
vector<vector<int>> edges;
vector<int> depth;

void dfs(int v){
    for(auto u : edges[v]){
        if(depth[u] == -1){
            depth[u] = depth[v] % k + 1;
            dfs(u);
        }
    }
}

signed main(){
    cin >> n >> m >> k;
    edges.resize(n);
    depth.assign(n, -1);
    int qqq;
    
    for(int i = 0; i < n; i++){
        cin >> qqq;
    }
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
    depth[0] = 1;
    dfs(0);
    for(int i = 0; i < n; i++){
        cout << depth[i] << ' ';
    }
}