#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;

template <class T> bool ckmin(T &a,T b){ return a > b? a=b, true : false;}
template <class T> bool ckmax(T &a,T b){ return a < b? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define F first
#define S second

// const int N = 2e5 + 500;
const int mod = 1e9 + 7; //998244353
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;
const ld eps = 1e-9;

struct Point {
    ll x, y;

    ll operator ^ (const Point& p) const { return x*p.y - y*p.x; }
    Point operator - (const Point& p) const { return {x-p.x, y-p.y}; }
    Point operator + (const Point& p) const { return {x+p.x, y+p.y}; }
};

istream& operator >> (istream& is, Point& p) {
    return is >> p.x >> p.y;
}

ll sg(ll x) { return x > 0 ? 1 : x < 0 ? -1 : 0; }

bool does_intersect(const Point& a, const Point& b, const Point& c, const Point& d) {
    bool x = sg((c-a)^(b-a)) * sg((b-a)^(d-a)) == 1 
          && sg((b-c)^(d-c)) * sg((d-c)^(a-c)) == 1;
    // if (x) cout << "INT!" << endl;
    return x;
}

const int N =  300;

int n;
Point p[N];
vector<pi> seg, sgt_all;

bool okay(int i) {
    const Point P = p[sgt_all[i].F];
    const Point Q = p[sgt_all[i].S];
    for (int j = 0; j < seg.size(); ++j) {
        if (seg[j] == sgt_all[i]) return false;
        if (does_intersect(P, Q, p[seg[j].F], p[seg[j].S])) 
            return false;
    }
    return true;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> p[i];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j)
            sgt_all.eb(j, i);
    }

    for (int i = 0; i < sgt_all.size(); ++i) {  
        if (okay(i)) seg.eb(sgt_all[i].F, sgt_all[i].S);
    }

    int cnt = seg.size() % 2;
    seg.clear();
    cout << 2 - cnt << endl;
    int ptr = 0;
    for (int i = 0; ; ++i) {
        if (i % 2 == cnt) {
            int a, b; cin >> a >> b;
            if(!a || !b) break;
            seg.eb(a-1, b-1);
        } else {
            while (!okay(ptr)) ++ptr;
            cout << sgt_all[ptr].F+1 << " " << sgt_all[ptr].S+1 << endl;
            seg.pb(sgt_all[ptr]);
        }
    }

    return 0;
}