#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const int N = 2e5 + 10, INF = 2e9+10;
int n, k;
vector<int> v;

ll pre[31][31];

ll ans = 0;

void precalc() {
    pre[0][0] = 1;
    for (int i = 1; i <= 30; i++) {
        for (int j = 0; j <= i; j++) {
            pre[i][j] = pre[i-1][j-1] + pre[i-1][j];
        }
    }
}

void add_ans() {
    int cnt = 0, last = 0;
    ll d = 1;
    for (int i = 0; i < v.size(); i++) {
//        cout << v[i] << " ";
        if (v[i] == last) {
            cnt++;
        } else {
            d *= pre[cnt+k-1][k-1];
            cnt = 1;
        }
        last = v[i];
    }
    d *= pre[cnt+k-1][k-1];
    ans += d;
}

void f(int last, int s) {
    if (s == n) {
        add_ans();
    } else {
        for (int i = last; i <= min(n, n - s); i++) {
            v.push_back(i);
            f(i, s + i);
            v.pop_back();
        }
    }
}
int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;

    precalc();
    ans = 0;
    f(1, 0);
    cout << ans;

    return 0;
}