#include <bits/stdc++.h>

#define int long long
using namespace std;
#define sz(x) (int)(x).size()

const int N = 5e5 + 100;
vector<int> gr[N];
bool used[N];
int col[N];
int k;
void dfs(int v){
    used[v] = true;
    for(int u : gr[v]){
        if(!used[u]){
            col[u] = (col[v] + 1) % k;
            dfs(u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m >> k;
    int c;
    for(int i = 0; i < n; ++i) cin >> c;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    col[1] = 0;
    dfs(1);
    for(int i = 1; i <= n; ++i) cout << 1 + col[i] << ' ';
}
