#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair 
#define pb push_back 

#include <iostream>
#include <algorithm>
#include <math.h>
#include <stack>
#include <vector>
#include <queue>
#include <iomanip>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll maxn = 2e5 + 1;
const ll alp = 30;
const ll inf = 1e9 + 10;
const ll mod = 1e9 + 7;

char t[1010][1010];

int n, m;
int used[1010 * 1010];

int cntv = 0;

void dfs(int v) {
	++cntv;
	used[v] = cntv % 2 + 1;
	for (int to : g[v]) {
		if (!used[to])
			dfs(to);
	}
}

bool isEx(int x, int y) {
	if (x < 0)
		return false;
	if (y < 0)
		return false;
	if (x >= n)
		return false;
	if (y >= m)
		return false;
}

struct divan {
	int x, y;
	char c;
};

vector < divan > a;

int ndiv[1010][1010];
int tdiv[1010][1010];

bool cap(char c) {
	return c >= 'A' && c <= 'Z';
}

vector < int > g[1010 * 1010];

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen("notepad.in", "r", stdin);
	//freopen("notepad.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	
	cin >> n >> m;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> t[i][j];
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (isEx(i, j + 1) && t[i][j + 1] == t[i][j]) {
				a.push_back({ i, j, t[i][j] });
				tdiv[i][j + 1] = a.size();
				tdiv[i][j] = a.size();
				
				if (cap(t[i][j])) {
					if (isEx(i + 1, j) && tdiv[i + 1][j] != 0) {
						continue;
					}
					else if (isEx(i + 1, j)) {
						tdiv[i + 1][j] = a.size();
					}
					if (isEx(i + 1, j + 1) && tdiv[i + 1][j + 1] != 0) {
						continue;
					}
					else if (isEx(i + 1, j + 1)) {
						tdiv[i + 1][j + 1] = a.size();
					}
					if (isEx(i + 1, j) && ndiv[i + 1][j] != 0) {
						g[a.size()].push_back(ndiv[i + 1][j]);
						g[ndiv[i + 1][j]].push_back(a.size());
					}
					else if (isEx(i + 1, j)) {
						ndiv[i + 1][j] = a.size();
					}
					if (isEx(i + 1, j + 1) && ndiv[i + 1][j + 1] != 0) {
						g[a.size()].push_back(ndiv[i + 1][j + 1]);
						g[ndiv[i + 1][j + 1]].push_back(a.size());
					}
					else if (isEx(i + 1, j + 1)) {
						ndiv[i + 1][j + 1] = a.size();
					}
				}
				else {
					if (isEx(i - 1, j) && tdiv[i - 1][j] != 0) {
						continue;
					}
					else if (isEx(i - 1, j)) {
						tdiv[i - 1][j] = a.size();
					}
					if (isEx(i - 1, j + 1) && tdiv[i - 1][j + 1] != 0) {
						continue;
					}
					else if (isEx(i - 1, j + 1)) {
						tdiv[i - 1][j + 1] = a.size();
					}
					if (isEx(i - 1, j) && ndiv[i - 1][j] != 0) {
						g[a.size()].push_back(ndiv[i - 1][j]);
						g[ndiv[i - 1][j]].push_back(a.size());
					}
					else if (isEx(i - 1, j)) {
						ndiv[i - 1][j] = a.size();
					}
					if (isEx(i - 1, j + 1) && ndiv[i - 1][j + 1] != 0) {
						g[a.size()].push_back(ndiv[i - 1][j + 1]);
						g[ndiv[i - 1][j + 1]].push_back(a.size());
					}
					else if (isEx(i - 1, j + 1)) {
						ndiv[i - 1][j + 1] = a.size();
					}
				}
			}

			if (isEx(i + 1, j) && t[i + 1][j] == t[i][j]) {

				a.push_back({ i, j, t[i][j] });
				tdiv[i][j + 1] = a.size();
				tdiv[i][j] = a.size();
				if (isEx(i, j + 1) && tdiv[i + 1][j] != 0) {
					continue;
				}
				else if (isEx(i, j + 1)) {
					tdiv[i + 1][j] = a.size();
				}
				if (isEx(i, j + 1 + 1) && tdiv[i + 1][j + 1] != 0) {
					continue;
				}
				else if (isEx(i, j + 1)) {
					tdiv[i + 1][j + 1] = a.size();
				}
				if (isEx(i, j + 1) && ndiv[i + 1][j] != 0) {
					g[a.size()].push_back(ndiv[i + 1][j]);
					g[ndiv[i + 1][j]].push_back(a.size());
				}
				else if (isEx(i, j + 1)) {
					ndiv[i + 1][j] = a.size();
				}
				if (isEx(i, j + 1 + 1) && ndiv[i + 1][j + 1] != 0) {
					g[a.size()].push_back(ndiv[i + 1][j + 1]);
					g[ndiv[i + 1][j + 1]].push_back(a.size());
				}
				else if (isEx(i, j + 1 + 1)) {
					ndiv[i + 1][j + 1] = a.size();
				}
			}
			else {
				if (isEx(i - 1, j) && tdiv[i - 1][j] != 0) {
					continue;
				}
				else if (isEx(i - 1, j)) {
					tdiv[i - 1][j] = a.size();
				}
				if (isEx(i - 1, j - 1) && tdiv[i - 1][j - 1] != 0) {
					continue;
				}
				else if (isEx(i - 1, j - 1)) {
					tdiv[i - 1][j - 1] = a.size();
				}
				if (isEx(i - 1, j) && ndiv[i - 1][j] != 0) {
					g[a.size()].push_back(ndiv[i - 1][j]);
					g[ndiv[i - 1][j]].push_back(a.size());
				}
				else if (isEx(i - 1, j)) {
					ndiv[i - 1][j] = a.size();
				}
				if (isEx(i - 1, j - 1) && ndiv[i - 1][j - 1] != 0) {
					g[a.size()].push_back(ndiv[i - 1][j - 1]);
					g[ndiv[i - 1][j - 1]].push_back(a.size());
				}
				else if (isEx(i - 1, j - 1)) {
					ndiv[i - 1][j - 1] = a.size();
				}
			}
		}
	}

	for (int i = 1; i <= a.size(); ++i) {
		cntv = 0;
		if (!used[i])
			dfs(i);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (used[i * 1010][j]) {
				t[i][j] = i * 1010 + j;
				if (isEx(i, j + 1) && t[i][j + 1] == t[i][j]) {
					a.push_back({ i, j, t[i][j] });
					tdiv[i][j + 1] = a.size();
					tdiv[i][j] = a.size();

					if (cap(t[i][j])) {
						if (isEx(i + 1, j) && tdiv[i + 1][j] != 0) {
							continue;
						}
						else if (isEx(i + 1, j)) {
							tdiv[i + 1][j] = a.size();
						}
						if (isEx(i + 1, j + 1) && tdiv[i + 1][j + 1] != 0) {
							continue;
						}
						else if (isEx(i + 1, j + 1)) {
							tdiv[i + 1][j + 1] = a.size();
						}
						if (isEx(i + 1, j) && t[i + 1][j] != 0) {
							g[a.size()].push_back(t[i + 1][j]);
							g[t[i + 1][j]].push_back(a.size());
						}
						else if (isEx(i + 1, j)) {
							t[i + 1][j] = a.size();
						}
						if (isEx(i + 1, j + 1) && t[i + 1][j + 1] != 0) {
							g[a.size()].push_back(t[i + 1][j + 1]);
							g[t[i + 1][j + 1]].push_back(a.size());
						}
						else if (isEx(i + 1, j + 1)) {
							t[i + 1][j + 1] = a.size();
						}
					}
					else {
						if (isEx(i - 1, j) && tdiv[i - 1][j] != 0) {
							continue;
						}
						else if (isEx(i - 1, j)) {
							tdiv[i - 1][j] = a.size();
						}
						if (isEx(i - 1, j + 1) && tdiv[i - 1][j + 1] != 0) {
							continue;
						}
						else if (isEx(i - 1, j + 1)) {
							tdiv[i - 1][j + 1] = a.size();
						}
						if (isEx(i - 1, j) && t[i - 1][j] != 0) {
							g[a.size()].push_back(t[i - 1][j]);
							g[t[i - 1][j]].push_back(a.size());
						}
						else if (isEx(i - 1, j)) {
							t[i - 1][j] = a.size();
						}
						if (isEx(i - 1, j + 1) && t[i - 1][j + 1] != 0) {
							g[a.size()].push_back(t[i - 1][j + 1]);
							g[t[i - 1][j + 1]].push_back(a.size());
						}
						else if (isEx(i - 1, j + 1)) {
							t[i - 1][j + 1] = a.size();
						}
					}
				}

				if (isEx(i + 1, j) && t[i + 1][j] == t[i][j]) {

					a.push_back({ i, j, t[i][j] });
					tdiv[i][j + 1] = a.size();
					tdiv[i][j] = a.size();
					if (isEx(i, j + 1) && tdiv[i + 1][j] != 0) {
						continue;
					}
					else if (isEx(i, j + 1)) {
						tdiv[i + 1][j] = a.size();
					}
					if (isEx(i, j + 1 + 1) && tdiv[i + 1][j + 1] != 0) {
						continue;
					}
					else if (isEx(i, j + 1)) {
						tdiv[i + 1][j + 1] = a.size();
					}
					if (isEx(i, j + 1) && t[i + 1][j] != 0) {
						g[a.size()].push_back(t[i + 1][j]);
						g[t[i + 1][j]].push_back(a.size());
					}
					else if (isEx(i, j + 1)) {
						t[i + 1][j] = a.size();
					}
					if (isEx(i, j + 1 + 1) && t[i + 1][j + 1] != 0) {
						g[a.size()].push_back(t[i + 1][j + 1]);
						g[t[i + 1][j + 1]].push_back(a.size());
					}
					else if (isEx(i, j + 1 + 1)) {
						t[i + 1][j + 1] = a.size();
					}
				}
				else {
					if (isEx(i - 1, j) && tdiv[i - 1][j] != 0) {
						continue;
					}
					else if (isEx(i - 1, j)) {
						tdiv[i - 1][j] = a.size();
					}
					if (isEx(i - 1, j - 1) && tdiv[i - 1][j - 1] != 0) {
						continue;
					}
					else if (isEx(i - 1, j - 1)) {
						tdiv[i - 1][j - 1] = a.size();
					}
					if (isEx(i - 1, j) && t[i - 1][j] != 0) {
						g[a.size()].push_back(t[i - 1][j]);
						g[t[i - 1][j]].push_back(a.size());
					}
					else if (isEx(i - 1, j)) {
						t[i - 1][j] = a.size();
					}
					if (isEx(i - 1, j - 1) && t[i - 1][j - 1] != 0) {
						g[a.size()].push_back(t[i - 1][j - 1]);
						g[t[i - 1][j - 1]].push_back(a.size());
					}
					else if (isEx(i - 1, j - 1)) {
						t[i - 1][j - 1] = a.size();
					}
				}
			}
		}
	}

}