#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define pll pair<ll,ll>
#define pii pair<int,int>
#define all(v) v.begin(),v.end()
#define ld long double
#define y1 Enkognit

using namespace std;

ll n, m, k;

struct pt {
    int x, y;
};


bool cmp (pt a, pt b) {
        return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw (pt a, pt b, pt c) {
        return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}
bool ccw (pt a, pt b, pt c) {
        return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}
void convex_hull (vector<pt> & a) {
        if (a.size() == 1)  return;
        sort (a.begin(), a.end(), &cmp);
        pt p1 = a[0],  p2 = a.back();
        vector<pt> up, down;
        up.push_back (p1);
        down.push_back (p1);
        for (size_t i=1; i<a.size(); ++i) {
                if (i==a.size()-1 || cw (p1, a[i], p2)) {
                        while (up.size()>=2 && !cw (up[up.size()-2], up[up.size()-1], a[i]))
                                up.pop_back();
                        up.push_back (a[i]);
                }
                if (i==a.size()-1 || ccw (p1, a[i], p2)) {
                        while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i]))
                                down.pop_back();
                        down.push_back (a[i]);
                }
        }
        a.clear();
        for (size_t i=0; i<up.size(); ++i)
                a.push_back (up[i]);
        for (size_t i=down.size()-2; i>0; --i)
                a.push_back (down[i]);
}

inline int area (pt a, pt b, pt c) {
        return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

inline bool intersect_1 (int a, int b, int c, int d) {
        if (a > b)  swap (a, b);
        if (c > d)  swap (c, d);
        return max(a,c) <= min(b,d);
}

bool operator == (pt a,pt b)
{
    return a.x==b.x && a.y==b.y;
}

bool intersect(pt a, pt b, pt c, pt d) {
        /*cout << a.x << " " << a.y << "\n";
        cout << b.x << " " << b.y << "\n";
        cout << c.x << " " << c.y << "\n";
        cout << d.x << " " << d.y << "\n";
        //cout << (a.x==c.x) << "\n";*/
        ll o=(int)(a==c)+(int)(b==d)+(int)(b==c)+(int)(a==d);
        /*cout << o << "\n";
        cout << "----\n";*/
        if (o==1) return 0;
        return intersect_1 (a.x, b.x, c.x, d.x)
                && intersect_1 (a.y, b.y, c.y, d.y)
                && area(a,b,c) * area(a,b,d) <= 0
                && area(c,d,a) * area(c,d,b) <= 0;
}


void slave()
{
    cin >> n;
    vector<pt> v;
    for (int i = 1; i <= n; i++)
    {
        ll x, y;
        cin >> x >> y;
        pt u;
        u.x=x;
        u.y=y;
        v.pb(u);
    }
    vector<pt> z=v;
    convex_hull(z);
    ll t=1, i=0, j=1;
    if ((z.size()*2-3+(v.size()-z.size())*3)%2) cout << "1\n"; else {cout << "2\n";t=0;}
    vector<pair<pt, pt> > qq;
    while (1)
    {
        if (t)
        {
            ll x=0, y=0;
            ll zz=0;
            for (;i < v.size(); i++, j=i+1)
            {
                for (; j < v.size(); j++)
                {
                    bool tt=1;
                    for (int u = 0; u < qq.size(); u++)
                    {
                        if (intersect(qq[u].fi,qq[u].se,v[i],v[j])) {tt=0;break;}
                    }
                    if (tt)
                    {
                        zz=1;
                        x=i+1;
                        y=j+1;
                        break;
                    }
                }
                if (zz) break;
            }
            cout << x << " " << y << "\n";
            fflush(stdout);
            qq.pb(mp(v[x-1], v[y-1]));
        }else
        {
            ll x, y;
            cin >> x >> y;
            fflush(stdout);
            if (x==0) exit(0);
            qq.pb(mp(v[x-1], v[y-1]));
        }
        t=(t+1)%2;
    }
}

int main()
{
    ll t=1;
    //cin >> t;
    while (t--) slave();
}
