import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.security.PrivilegedExceptionAction;
import java.util.*;


public class MainClass {
    public static class event implements Comparable<event>{
        int type;
        int t;
        public event(int l, int r){
            this.type = l;
            this.t = r;
        }

        @Override
        public int compareTo(event o) {
            if(this.t == o.t){
                return this.type - o.type;
            }
            return this.t - o.t;
        }
    }
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        int m = Integer.parseInt(st.nextToken());
        int s = Integer.parseInt(st.nextToken());
        st = new StringTokenizer(reader.readLine());
        ArrayList<Integer> arr = new ArrayList<>();
        TreeSet<Integer> set = new TreeSet<>();
        for(int i = 0; i < m; ++i){
            set.add(Integer.parseInt(st.nextToken()));
        }
        arr.addAll(set);
        Collections.sort(arr);
        ArrayList<event> otr = new ArrayList<>();
        for(int r = m - s - 1; r < arr.size(); ++r){
            int l = r - m + s + 1;
            if(arr.get(r) - arr.get(l) > m){
                continue;
            }
            int len = s - (arr.get(r) - arr.get(l) - m + s + 1);
            int ll = Math.max(1, arr.get(l) - len);
            otr.add(new event(1, ll));
            otr.add(new event(2, arr.get(l)));
        }
        otr.add(new event(2, n - m + 1));
        Collections.sort(otr);
        int lastl = -1;
        int opened = 0;
        int ans = 0;
        for(event e : otr){
            if(e.type == 2){
                --opened;
                if(opened == 0){
                    ans += e.t - lastl + 1;
                    lastl = -1;
                }
                else if(e.t == n - m + 1){
                    if(lastl != -1) {
                        ans += e.t - lastl + 1;
                        break;
                    }
                    else{
                        break;
                    }
                }
            }
            else{
                ++opened;
                if(opened == 1){
                    lastl = e.t;
                }
            }
        }
        System.out.println(ans);
    }
}