// #pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
// #pragma GCC target("avx,avx2")
#include <random>
#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
using namespace std;

#ifdef DEBUG
const string PROBLEM = "task";
ifstream fin(PROBLEM + ".in");
ofstream fout(PROBLEM + ".out");
#define cin fin
#define cout fout
#define cerr fout
#endif

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

random_device rd;
mt19937 Random(rd());
const int inf = 1e9;
const ll llinf = 1e18;
const ld eps = 1e-7;
const int mod = 1e9 + 7;

//----------------------------------------------------------------
namespace std {
	template<class T, class T1>
	struct hash<pair<T, T1>> {
		size_t operator()(const pll& a) const {
			return hash<ll>()(a.first) * 90357035849ULL + hash<ll>()(a.second) * 5904750302384ULL;
		}
	};

	template<>
	struct hash<pair<pll, ll>> {
		size_t operator()(const pair<pll, ll>& a) const {
			return hash<pll>()(a.first) * 393848565794ULL + hash<ll>()(a.second) * 2395687566846ULL;
		}
	};

	template <class T, class T1>
	ostream& operator<<(ostream& os, const pair<T, T1>& a) {
		return os << a.first << ' ' << a.second << '\n';
	}
	template <class T, class T1>
	istream& operator>>(istream& in, pair<T, T1>& a) {
		return in >> a.first >> a.second;
	}
	template <class T>
	istream& operator>>(istream& in, vector<T>& a) {
		for (auto& i : a) in >> i;
		return in;
	}
	template <class T>
	ostream& operator<<(ostream& out, const vector<T>& a) {
		for (auto& i : a) out << i << ' ';
		return out << '\n';
	}
}
//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io ios::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define debug(x) cerr << #x << ": " << x << '\n'
#define bruh break
#define nbruh continue
#define mp make_pair
using namespace std;

ll mx(ll& a, ll b) { return (a > b ? a : a = b); }
int mx(int& a, int b) { return (a > b ? a : a = b); }
ll mn(ll& a, ll b) { return (a < b ? a : a = b); }
int mn(int& a, int b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

int main() {
#ifndef DEBUG
	fast_io;
#endif
	cout << setprecision(15) << fixed;
	cerr << setprecision(15) << fixed;
	ld START_TIME = clock();

	int nums[5] = { 1,3,6,11,20 };
	int alf[5] = { 1,2,4,8,16 };
	int n;
	cin >> n;
	if (n == 0) {
		cout << 1;
		return 0;
	}
	int curalf = 0;
	for (int i = 0; i < 5; ++i) {
		if (n == nums[i]) {
			curalf = alf[i];
			break;
		}
		if (n < nums[i]) {
			curalf = alf[i];
			break;
		}
	}
	int len = 0;
	int maxlen = (1 << n);
	int num = 0;
	while (len < maxlen) {
		len += curalf;
		for (int i = 0; i < curalf; ++i)
			if (num & (1<<i))
				cout << 1;
			else
				cout << 0;
		++num;
	}

	cerr << '\n';
	ld TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
	debug(TIME);
	return 0;
}
