#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<pair<long long, long long>> a(n);
        long long suma = 0;
        for(int i = 0; i < n; ++i){
            cin >> a[i].first;
            suma += a[i].first;
        }
        for(int i = 0; i < n; ++i){
            cin >> a[i].second;
        }
        int ind = -1;
        for(int i = 0; i < n; ++i){
            if(a[i].second > suma){
                if(ind == -1){
                    ind = i;
                }
                else{
                    ind = -2;
                    break;
                }
            }
        }
        long long sum_a = 0, free_a = 0;
        if(ind == -2){
            cout << "NO\n";
            break;
        }
        else if(ind != -1){
            swap(a[ind], a.back());
            free_a = a.back().first;
            a.pop_back();
        }
        sort(a.begin(), a.end(), [](pair<long long, long long> a, pair<long long, long long> b){
            return a.second - a.first < b.second - b.first;
        });
        if(ind == -1){
            free_a = a.back().first;
            a.pop_back();
        }
        long long b0 = 0;
        while(ind != a.size()) {
            if(a.size() == 1){
                b0 = max(0ll, b0 - a.back().first) + a.back().second - sum_a;
                break;
            }
            b0 += a.back().second;
            sum_a += a.back().first;
            a.pop_back();

            ind = 0;
            for (; ind < a.size() && sum_a >= a[ind].second; ++ind) {
                sum_a -= a[ind].second;
                free_a += a[ind].first;
            }
        }
        if(b0 <= free_a){
            cout << "YES\n";
        }
        else{
            cout << "NO\n";
        }
    }

    return 0;
}