﻿#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <cstdlib>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>

using namespace std;

#define all(x) x.begin(), x.end()
#define int long long

const int INF = LLONG_MAX;
const int mod = 1e9 + 7;
const double eps = 1e-7;

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
};

void solveF() {
	int t1, v1, t2, v2; cin >> t1 >> v1 >> t2 >> v2;
	if (t2 < 0 && v2 >= 10) cout << "A storm warning for tomorrow! Be careful and stay home if possible!";
	else if (t2 < t1) cout << "MCHS warns! Low temperature is expected tomorrow.";
	else if (v2 > v1) cout << "MCHS warns! Strong wind is expected tomorrow.";
	else cout << "No message";
}

void solveA() {
	int a; cin >> a;
	double com = 25 + a * 1.0 / 100;
	if (com < 100) com = 100;
	if (com > 2000) com = 2000;
	cout << fixed << setprecision(2) << com;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _tests = 1;
	//cin >> _tests;
	while (_tests--) {
		solveA();
	}
}