#include <iostream>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

set <int> se;

int len2(int x)
{
    int ans = 0;
    while (x > 0){
        ans++;
        x /= 2;
    }
    return max(ans, 1);
}

string tobin(int x, int n)
{
    string ans;
    while (x > 0){
        ans.push_back(x % 2 + '0');
        x /= 2;
    }
    while (ans.length() < n)
        ans += "0";
    reverse(ans.begin(), ans.end());
    return ans;
}

int main()
{
    int n;
    cin >> n;
    string s = "";
    int j = 1;
    while (s.length() < (1 << n)){
        se.clear();
        int ans = 0;
        for (int i = 0; i < s.length(); i++){
            ans += (s[i] - '0') * (1 << (j - 1 - i % j));
            if (j - 1 - i % j == 0){
                se.insert(ans);
                ans = 0;
            }
        }
        for (int i = 0; i < (1 << j); i++)
            if (se.find(i) == se.end())
                s += tobin(i, j);
        j++;
    }
    while (s.length() > (1 << n))
        s.pop_back();
    cout << s << '\n';
    return 0;
}
