#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <assert.h>
#include <string>
#include <deque>
#include <iomanip>
#include <map>

using namespace std;

typedef long long ll;

ll l, r;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	return a * bin_pow(a, n - 1);
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	int t; cin >> t;
	while (t--) {
		int n; cin >> n;
		vector <int> a(n), b(n);
		ll sum1 = 0, sum2 = 0;
		for (int i = 0; i < n; i++) { cin >> a[i]; sum1 += a[i]; }
		for (int i = 0; i < n; i++) { cin >> b[i]; sum2 += b[i]; }
		ll ind = -1, mx = -1e18;
		for (int i = 0; i < n; i++) {
			if (b[i] - a[i] > mx) {
				mx = b[i] - a[i];
				ind = i;
			}
		}
		sum2 -= b[ind];
		bool fl = 0;
		for (int i = 0; i < n; i++) {
			if (i == ind) continue;
			if (sum1 - a[i] >= b[i] && sum1 >= sum2) continue;
			else {
				cout << "NO\n";
				fl = 1;
				break;
			}
		}
		if (!fl) cout << "YES\n";
	}
	return 0;
}