﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>

#define rep(i, n) for(ll i = 0; i < n; ++i)
#define in(x, a) for(auto x : a)
#define inl(x, a) for(auto& x : a)

using namespace std;

using ll = long long;
ll const INF = 1e9;
ll const MOD = 1e9 + 7;

int n, t;

string gen(int num) {
    string res;
    for (int i = 0; i < (1 << t); ++i) {
        if (num % 2 == 0)
            res += "0";
        else
            res += "1";
        num /= 2;
    }
    return res;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string answer;
    cin >> n;
    int deg2 = 1;
    for (int i = 1; i < n; ++i) {
        deg2 *= 2;
        if ((deg2 + i) > n) {
            t = i - 1;
            break;
        }
    }
    for (int i = 0; i < (1 << (1 << t)); ++i)
        answer += gen(i);
    int count = (1 << (1 << t));
    int this_num1 = 0, this_num2 = 0;
    while (count < (1 << (n - t))) {
        if (this_num2 == (1 << (1 << t))) {
            this_num2 = 0;
            ++this_num1;
        }
        if ((this_num1 + 1) == this_num2 && this_num1 % 2 == 0) {
            ++this_num2;
            continue;
        }
        answer += gen(this_num1) + gen(this_num2);
        ++this_num2;
        count += 2;
    }
    cout << answer;
}