﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>

#define rep(i, n) for(ll i = 0; i < n; ++i)
#define in(x, a) for(auto x : a)
#define inl(x, a) for(auto& x : a)

using namespace std;

using ll = long long;
ll const INF = 1e9;
ll const MOD = 1e9 + 7;

ll ans;
vector<ll> cur;
map<ll, ll> cnt;

void gen(ll n, ll sum) {
    if (sum == n) {
        ll t = 1;
        in(p, cnt) {
            t *= p.second + 1;
        }
        ans += t;
        return;
    }
    if (sum > n) {
        return;
    }
    for (int i = cur.back(); i <= n - sum; ++i) {
        cur.push_back(i);
        cnt[i]++;
        gen(n, sum + i);
        cur.pop_back();
        cnt[i]--;
        if (cnt[i] == 0) {
            cnt.erase(i);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string answer;
    
    ll n, k;
    cin >> n >> k;
    for (ll i = 1; i <= n; ++i) {
        cur.push_back(i);
        cnt[i] = 1;
        gen(n, i);
        cur.pop_back();
        cnt.erase(i);
    }
    cout << ans;
}