#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

bool comp1(tuple<int, int, int> a, tuple<int, int, int> b) {
    return get<0>(a) / (double) get<1>(a) < get<0>(b) / (double) get<1>(b);
}

bool comp2(tuple<int, int, int> a, tuple<int, int, int> b) {
    return get<0>(a) - get<1>(a) < get<0>(b) - get<1>(b);
}

pair<int, vector<int>> f(vector<tuple<int, int, int>> &a, int W) {
    int x = 0;
    vector<int> res;
    for (auto el : a) {
        if (W >= get<0>(el)) {
            W -= get<0>(el);
            res.push_back(get<2>(el));
            x += get<1>(el);
        }
    }
    return {x, res};
}

void sol() {
    int n, W;
    cin >> n >> W;
    vector<tuple<int, int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> get<0>(a[i]) >> get<1>(a[i]);
        get<2>(a[i]) = i + 1;
    }
    W *= 3;
    W /= 2;
    sort(all(a), comp1);
    pair<int, vector<int>> ans = f(a, W);
    sort(all(a), comp2);
    ans = max(ans, f(a, W));
    cout << ans.second.size() << '\n';
    sort(all(ans.second));
    for (int el : ans.second) {
        cout << el << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}
