#include <bits/stdc++.h>
using namespace std;

//#define int long long

#define x1 x1228
#define y1 y1228

#define left left228
#define right right228

#define tm tm228

#define pb push_back
#define eb emplace_back
#define mp make_pair

#define ff first
#define ss second
#define f first
#define s second
#define F first
#define S second

#define rall(a) a.rbegin(), a.rend()
#define all(x) x.begin(), x.end()
#define debug(x) cout << #x << ": " << x << endl;
#define sz(x) (int)x.size()

#define TIME (ld)clock()/CLOCKS_PER_SEC

using namespace std;
typedef long long ll;
typedef double db;
typedef long double ld;
typedef pair < int, int > pii;

const int maxn = 3e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7;
const double eps = 1e-9;
const ll INF = 1e18, inf = 1e15;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Point {
    int x, y;
    Point(int _x, int _y) : x(_x), y(_y) {}
    Point() : x(0), y(0) {}
};

ostream& operator<<(ostream& os, const Point& p1) {
    os << p1.x << " " << p1.y;
    return os;
}

istream& operator>>(istream& os, Point& p1) {
    os >> p1.x >> p1.y;
    return os;
}

bool operator!=(Point p1, Point p2) {
    return p1.x != p2.x || p1.y != p2.y;
}

Point operator-(Point p1, Point p2) {
    return Point(p1.x - p2.x, p1.y - p2.y);
}

Point operator-(Point p1) {
    return Point(-p1.x, -p1.y);
}

Point operator+(Point p1, Point p2) {
    return Point(p1.x + p2.x, p1.y + p2.y);
}

double operator*(Point p1, Point p2) {
    return p1.x * p2.x + p1.y * p2.y;
}

Point operator*(Point p1, double x) {
    return Point(p1.x * x, p1.y * x);
}

Point operator/(Point p1, double x) {
    return Point(p1.x / x, p1.y / x);
}

double operator%(Point p1, Point p2) {
    return p1.x * p2.y - p2.x * p1.y;
}

double siz(Point p1) {
    return sqrt(p1.x * p1.x + p1.y * p1.y);
}

Point norm(Point p1) {
    return Point(-p1.y, p1.x);
}

int sign(double x) {
    if (x < 0) return -1;
    if (x == 0) return 0;
    return 1;
}

bool kek1(Point vt, Point p1) {
    return vt % p1 == 0 && vt * p1 >= 0;
}

bool operator==(Point a, Point b) {
    return (a.x == b.x && a.y == b.y);
}

bool get_intersection_segment(Point A, Point B, Point C, Point D) {
    if (A == C)
        return false;
    if (A == D)
        return false;
    if (B == C)
        return false;
    if (B == D)
        return false;
    int sig1 = sign((B - A) % (C - A)) * sign((B - A) % (D - A));
    int sig2 = sign((C - D) % (A - D)) * sign((C - D) % (B - D));
    if (sig1 < 0 && sig2 < 0) {
        return true;
    }
    if (sig1 > 0 || sig2 > 0) {
        return false;
    }
    if (sig1 == 0 && sig2 == 0) {
        int l = C.x;
        int r = D.x;
        if (l > r) swap(l, r);

        int l1 = A.x;
        int r1 = B.x;
        if (l1 > r1) swap(l1, r1);

        int l3 = C.y;
        int r3 = D.y;
        if (l3 > r3) swap(l3, r3);

        int l4 = A.y;
        int r4 = B.y;
        if (l4 > r4) swap(l4, r4);
        if (max(l, l1) > min(r, r1) || max(l3, l4) > min(r3, r4)) {
            return false;
        }
        return true;
    }
    Point vt1 = B - A, vt2 = C - D;
    if (kek1(vt1, C - A) && kek1(-vt1, C - B)) {
        return true;
    }
    if (kek1(vt1, D - A) && kek1(-vt1, D - B)) {
        return true;
    }
    if (kek1(vt2, A - D) && kek1(-vt2, A - C)) {
        return true;
    }
    if (kek1(vt2, B - D) && kek1(-vt2, B - C)) {
        return true;
    }
    return false;
}

bool onLine(Point A, Point B, Point C) {
    return (A - B) % (C - B) == 0;
}

bool point_on_vt(Point A, Point B, Point C)  {
    return onLine(A, B, C) && (A - B) * (C - B) >= 0 && (B - A) * (C - A) >= 0;
}

pair<int, Point> get_intersection(Point A, Point B, Point C, Point D) {
    Point O;
    Point v = B - A;
    int s1 = (C - A) % (D - A);
    int s2 = (D - B) % (C - B);
    int s = s1 + s2;
    if(s == 0) {
        if((D - C) % (B - A) == 0 && !onLine(C, D, A) && !onLine(A, B, C)) {
            return {0, Point(-1e10, -1e10)};
        }
        return {2, A};
    }
    v = v / s;
    v = v * s1;
    O = A + v;
    return {1, O};
}

void del(vector<pii> &a, pii xx) {
    vector<pii> nw;
    for (auto v : a) {
        if (v != xx && !(v.ff == xx.ss && v.ss == xx.ff)) nw.pb(v);
    }
    a = nw;
}

void solve() {
    int n;
    cin >> n;
    vector<Point> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<pair<int, int>> s;
    for (int i = 0; i < n; ++i)
        for (int j = i+1; j < n; ++j)
            s.pb({i, j});
    int c = 0;
    while (!s.empty()) {
        c++;
        auto p = s.back();
        s.pop_back();
        vector<pair<int, int>> nw;
        for (auto xy: s) {
            if (!get_intersection_segment(a[xy.f], a[xy.s], a[p.f], a[p.s]))
                nw.pb({xy.f, xy.s});
        }
        s = nw;
    }
    for (int i = 0; i < n; ++i)
        for (int j = i+1; j < n; ++j)
            s.pb({i, j});
    if (c%2 == 1) {
        cout << 1 << endl;
    } else {
        cout << 2 << endl;
        int i, j;
        cin >> i >> j;
        i--, j--;
        del(s, mp(i, j));
        vector<pair<int, int>> nw;
        for (auto xy: s) {
            if (!get_intersection_segment(a[xy.f], a[xy.s], a[i], a[j]))
                nw.pb({xy.f, xy.s});
        }
        s = nw;
    }
    while (!s.empty()) {
        auto p = s.back();
        cout << p.f+1 << ' ' << p.s+1 << endl;
        s.pop_back();
        vector<pair<int, int>> nw;
        for (auto xy: s) {
            int x = xy.ff;
            int y = xy.ss;
            if (!get_intersection_segment(a[x], a[y], a[p.f], a[p.s]))
                nw.pb({x, y});
        }
        s = nw;
        int i, j;
        cin >> i >> j;
        if (i == 0 && j == 0)
            return;
        i--, j--;
        del(s, mp(i, j));
        nw.clear();
        for (auto xy: s) {
            int x = xy.ff;
            int y = xy.ss;
            if (!get_intersection_segment(a[x], a[y], a[i], a[j]))
                nw.pb({x, y});
        }
        s = nw;
    }
}

signed main() {
#ifdef LOCAL
    //("TASK.in", "r", stdin);
    //freopen("TASK.out", "w", stdout);
#else

#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int t = 1;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
