#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <deque>
#include <iomanip>
#include <queue>

using namespace std;

void haha(int l, int r, int want, string& s, int cur) {
    if (want == cur) {
        cout << s.substr(l, r - l + 1);
        return;
    }
    int m = (l + r) / 2;
    if (cur % 2) {
        haha(l, m, want, s, cur + 1);
    } else {
        haha(m + 1, r, want, s, cur + 1);
    }
}

string to_kek(int a, int len) {
    string cur;
    for (int i = 0; i < len; ++i) {
        if ((a >> i) & 1) cur += "0";
        else cur += "1";
    }
    reverse(cur.begin(), cur.end());
    return cur;
}

int32_t main() {
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n >= 11) {
        string s;
        map <int, bool> d;
        for (int i = 0; i < (1 << 8); ++i) {
            s += to_kek(i, 8);
            if (i % 2 == 0) d[i * (1 << 8) + i + 1] = true;
        }
        for (int i = 0; i < (1 << 16); ++i) {
            if (s.size() == (1 << n)) break;
            if (!d.count(i)) {
                s += to_kek(i, 16);
            }
        }
        cout << s;
    } else if (n >= 6) {
        string s;
        map <int, bool> d;
        for (int i = 0; i < (1 << 4); ++i) {
            s += to_kek(i, 4);
            if (i % 2 == 0) d[i * (1 << 4) + i + 1] = true;
        }
        for (int i = 0; i < (1 << 8); ++i) {
            if (s.size() == (1 << n)) break;
            if (!d.count(i)) {
                s += to_kek(i, 8);
            }
        }
        cout << s;
    } else if (n >= 3){
        string s;
        map <int, bool> d;
        for (int i = 0; i < (1 << 2); ++i) {
            s += to_kek(i, 2);
            if (i % 2 == 0) d[i * (1 << 2) + i + 1] = true;
        }
        for (int i = 0; i < (1 << 4); ++i) {
            if (s.size() == (1 << n)) break;
            if (!d.count(i)) {
                s += to_kek(i, 4);
            }
        }
        cout << s;
    } else if (n == 2){
        cout << "0010";
    } else {
        cout << "01";
    }
}
