#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <deque>
#include <math.h>
#include <set>
#include <map>
#include <queue>
#include <bitset>

#define pb push_back
#define ll long long

using namespace std;

#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minim(x) min_element((x).begin(), (x).end())
#define maxim(x) max_element((x).begin(), (x).end())
#define fori(i, n) for (long long (i) = 0; (i) < (n); ++(i))

template <class T>
istream& operator >>(istream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in >> i;
    }
    return in;
}

template <class T>
ostream& operator <<(ostream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in << i << " ";
    }
    return in;
}

/*
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> treap;
/*.order_of_key()
*.find_by_order()  iter*/



/*#include <ext/rope>
using namespace __gnu_cxx;
// .mutable_reference_at(i) =
// erase default(vector) + mbegin, mend
// insert default or rope
// .substr(ind, len)
#define mbegin mutable_begin
#define mend mutable_end
#define changei mutable_reference_at
template <class T>
ostream& operator <<(ostream &in, rope<T> &arr)
{
    for (const T &i : arr)
    {
        in << i << " ";
    }
    return in;
}*/

signed main() {

    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    //cout.precision(40);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int t;
    cin >> t;
    for(int q = 0; q < t; ++q) {
        string l, r;
        ll a, b;
        cin >> a >> b;
        l = to_string(a);
        r = to_string(b);
        if(l.length() < r.length()) {
            string s = "";
            for(int i = 0; i < r.length() - l.length(); ++i) {
                s += "0";
            }
            l = s + l;
        }
        if(l.length() > r.length()) {
            string s = "";
            for(int i = 0; i < l.length() - r.length(); ++i) {
                s += "0";
            }
            r = s + r;
        }

        int n = l.size();
        int pref_ans = 0;
        int pref_len = 0;
        int cur = 0;
        for(int i = 0; i < n; ++i) {
            if(l[i] != r[i]) break;
            pref_len ++;
            if(i == 0){
                cur = 1;
                continue;
            }
            if(l[i] == l[i-1]) {
                cur += 1;
            }else{
                pref_ans = max(pref_ans, cur);
                cur = 1;
            }
        }

        pref_ans = max(pref_ans, cur);

        int mrg_ans = 0;
        ll mrg_cnt = 0;

        if(pref_len > 0){
            mrg_ans = 0;
            bool tr1 = false, tr2 = false;
            for(int i = pref_len; i < n; ++i) {
                if((!tr1 && l[pref_len - 1] < l[i]) || (!tr2 && l[pref_len-1] > r[i])) break;
                mrg_ans ++;
                if(l[pref_len - 1] > l[i])
                    tr1 = true;
                if(l[pref_len - 1] < r[i])
                    tr2 = true;
            }
            ll xl = 0, xr = 0;
            ll s = 0;
            for(int i = 0; i < pref_len; ++i) {
                s = 10*s + (l[i] - '0');
            }
            for(int i = pref_len; i < pref_len + mrg_ans; ++i) {
                s = 10*s + (l[pref_len - 1] - '0');
            }
            s *= pow(10, n - pref_len - mrg_ans);

            xl = max(s, a);

            s += max((double)(0), pow(10, n - pref_len - mrg_ans) - 1);
            xr = min(s, b);
            //cout << xl << ' ' << xr << ' ' << pow(10, n - pref_len - mrg_ans) - 1 << '\n';
            mrg_cnt = xr - xl + 1;

            mrg_ans += cur;
        }

        int end_ans = 0;
        ll end_cnt = 0;

        if(pref_len < n) {
            bool tr = true;
            if(r[pref_len] - l[pref_len] > 1) {
                end_ans = n - pref_len;
                end_cnt = r[pref_len] - l[pref_len] - 1;
            }else {
                for (int i = pref_len; i < n; ++i) {
                    if (l[i] < l[pref_len])
                        break;
                    if (l[i] > l[pref_len]) {
                        tr = false;
                        break;
                    }
                }
                if(tr)
                    end_cnt ++;

                tr = true;
                for (int i = pref_len; i < n; ++i) {
                    if (r[i] > r[pref_len])
                        break;
                    if (r[i] < r[pref_len]) {
                        tr = false;
                        break;
                    }
                }
                if(tr)
                    end_cnt ++;

                if(end_cnt > 0)
                    end_ans = n - pref_len;
            }
            if(end_cnt == 0) {
                end_ans = n - pref_len - 1;


                ll s = 0;
                for(int i = 0; i < pref_len + 1; ++i) {
                    s = 10*s + (l[i] - '0');
                }
                s = s*pow(10, n - pref_len - 1);
                int t = 0;
                for(int i = 0; i <= 9; ++i) {
                    if(a <= s + ((pow(10, n - pref_len - 1) - 1) / 9)*i){
                        t = i;
                        break;
                    }
                }
                end_cnt += (9 - t + 1);

                s += ((pow(10, n - pref_len - 1) - 1) / 9)*(l[pref_len] - '0');
                s = (s / 10) * 10;
                for(int i = 0; i <= 9; ++i){
                    if(s + i >= a){
                        end_cnt ++;
                        //cout << "ha: " << i << ' ' << s << '\n';
                    }
                }

                s = 0;
                for(int i = 0; i < pref_len + 1; ++i) {
                    s = 10*s + (r[i] - '0');
                }
                s = s*pow(10, n - pref_len - 1);
                t = 0;
                for(int i = 9; i >= 0; --i) {
                    if(b >= s + ((pow(10, n - pref_len - 1) - 1) / 9)*i){
                        t = i;
                        break;
                    }
                }
                end_cnt += t + 1;

                s += ((pow(10, n - pref_len - 1) - 1) / 9)*(r[pref_len] - '0');
                s = (s / 10) * 10;
                for(int i = 0; i <= 9; ++i){
                    if(s + i <= b){
                        end_cnt ++;
                    }
                }
            }
        }
        ll k = b - a;
        if(pref_ans >= mrg_ans && pref_ans >= end_ans) {
            cout << pref_ans << ' ' << k;
        }else if(mrg_ans == end_ans) {
            cout << mrg_ans << ' ' << (mrg_cnt + end_cnt);
        }else if(mrg_ans > end_ans){
            //cout << "nice\n";
            cout << mrg_ans << ' ' << mrg_cnt;
        }else{
            //cout << "nice\n";
            cout << end_ans << ' ' << end_cnt;
        }
    }


}







