#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <deque>
#include <math.h>
#include <set>
#include <map>
#include <queue>
#include <bitset>

#define pb push_back
#define ll long long

using namespace std;

#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minim(x) min_element((x).begin(), (x).end())
#define maxim(x) max_element((x).begin(), (x).end())
#define fori(i, n) for (long long (i) = 0; (i) < (n); ++(i))

template <class T>
istream& operator >>(istream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in >> i;
    }
    return in;
}

template <class T>
ostream& operator <<(ostream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in << i << " ";
    }
    return in;
}

/*
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> treap;
/*.order_of_key()
*.find_by_order()  iter*/



/*#include <ext/rope>
using namespace __gnu_cxx;
// .mutable_reference_at(i) =
// erase default(vector) + mbegin, mend
// insert default or rope
// .substr(ind, len)
#define mbegin mutable_begin
#define mend mutable_end
#define changei mutable_reference_at
template <class T>
ostream& operator <<(ostream &in, rope<T> &arr)
{
    for (const T &i : arr)
    {
        in << i << " ";
    }
    return in;
}*/

int n, m, s;
vector<int> a;

bool check(int i, int pos) {

    int end = pos + m - 1;
    int l_ = i, r_ = m;
    while(r_ - l_ > 1) {
        int m_ = (l_ + r_) / 2;
        if(a[m_] <= end) {
            l_ = m_;
        }else {
            r_ = m_;
        }
    }

    int cur = m - (a[l_] - a[i] + 1);
    if(a[l_] > end) {
        cur = m;
    }
    if(cur <= s) {
        return true;
    }
    return false;
}

signed main()
{

    cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(false);
    //cout.precision(40);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n >> m >> s;
    vector<int> x(m);
    cin >> x;
    sort(all(x));

    a.push_back(x[0]);
    for(int i = 1; i < m; ++i) {
        if(x[i] != x[i-1]) {
            a.push_back(x[i]);
        }
    }

    ll ans = 0;
    for(int i = 0; i < m; ++i) {
        int l = 0;
        if(i > 0) {
            l = a[i-1];
        }
        int r = min(a[i], n - m + 1) + 1;
        while(r - l > 1) {
            int mid = (l + r) / 2;
            //cout << mid << ' ' << l << ' ' << r << '\n';
            if(check(i, mid)) {
                r = mid;
            }else{
                l = mid;
            }
        }
        //cout << i << ' ' << r << '\n';
        if(check(i, r) && r <= a[i]) {
            if(a[i] + m - 1 > n) {
                ans += (ll)((n - m + 1) - r + 1);
            }else{
                ans += (ll)(a[i] - r + 1);
            }
            //cout << "nice " << a[i] - r + 1 << '\n';
            //cout << i << ' ' << r << ' ' << (a[i] - r + 1) << '\n';
        }
    }
    //cout << check(1, 2) << '\n';
    cout << ans;
}







