#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <deque>
#include <math.h>
#include <set>
#include <map>
#include <queue>
#include <bitset>

#define pb push_back
#define ll long long

using namespace std;

#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minim(x) min_element((x).begin(), (x).end())
#define maxim(x) max_element((x).begin(), (x).end())
#define fori(i, n) for (long long (i) = 0; (i) < (n); ++(i))

template <class T>
istream& operator >>(istream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in >> i;
    }
    return in;
}

template <class T>
ostream& operator <<(ostream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in << i << " ";
    }
    return in;
}

/*
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> treap;
/*.order_of_key()
*.find_by_order()  iter*/



/*#include <ext/rope>
using namespace __gnu_cxx;
// .mutable_reference_at(i) =
// erase default(vector) + mbegin, mend
// insert default or rope
// .substr(ind, len)
#define mbegin mutable_begin
#define mend mutable_end
#define changei mutable_reference_at
template <class T>
ostream& operator <<(ostream &in, rope<T> &arr)
{
    for (const T &i : arr)
    {
        in << i << " ";
    }
    return in;
}*/


signed main()
{

    cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(false);
    //cout.precision(40);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ll n, m,s;
    cin >> n >> m >> s;
    set<ll> g;
    for (int i = 0; i < m; ++i)
    {
        ll r;
        cin >> r;
        g.insert(r);
    }
    deque<ll> e;
    ll pr = 0;
    ll ans = 0;
    ll need = m - s;
    for (auto u: g)
    {
        e.pb(u);
        while (e[ e.size() - 1 ] - e[0] > m or e.size() > need)
        {
            e.pop_front();
        }
       if (e.size() < need)
        {
            continue;
        }
        else
        {
            ll l, r;
            l = e[ e.size() - 1 ] - m;
            r = e[0];
            l = max(pr + 1, l);
            pr = max(r, pr);
            ans += max(r - l + 1, 0ll);
            //cout << l << " " << r << endl;
        }

    }
    cout << ans << endl;
}







