// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,unroll-all-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define ll long long
#define int ll
#define ld long double
#define pb push_back
#define pll pair<ll, ll>
#define ff first
#define ss second
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define mp make_pair

using namespace std;

const int p = 31;
const int mod = 1e9 + 7;
const int max_n = 2e3 + 5;
const int log_n = 20;
const int inf = 1e17;
const long double pi = acos(-1);
const ld eps = 1e-11;
const int len = 400;

std::mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Bag{
    int w, cost, id;

    Bag() {}

    Bag(int w, int cost, int id) : w(w), cost(cost), id(id) {} 
};

void run() {
    int n, w;
    cin >> n >> w;
    vector<Bag> a(n);
    rep(i, n) {
        cin >> a[i].w >> a[i].cost;
        a[i].id = i;
    }
    sort(all(a), [](Bag p1, Bag p2) {
        if (p1.cost * p2.w == p2.cost * p1.w) return p1.cost > p2.cost;
        return p1.cost * p2.w > p2.cost * p1.w;
    });

    vector<int> ans;
    w *= 3;
    w /= 2;
    rep(i, n) {
        if (a[i].w <= w) {
            ans.pb(a[i].id);
            w -= a[i].w;
        }
    }
    cout << ans.size() << '\n';
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
#ifndef ONLINE_JUDGE
    // files("input.txt", "output.txt");
#endif
    // files("optimize.in", "optimize.out");
    // srand(time(0));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        run();
    return 0;
}