#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector,btr-bb-exclusive,fast-math")

#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, w;

int calc(const vector< tuple<int, int, int> >& aa) {
	int curw = 0;
	int curc = 0;
	for(auto [ww, cc, ii]: aa) {
		if(curw + ww <= w) {
			curw += ww;
			curc += cc;
		}
	}
	return curc;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	for(int q = 0; q < t; q++) {
		int clock_start = clock();

		cin >> n >> w;
		w = w + w / 2;

		vector< tuple<int, int, int> > aa(n);
		for(int i = 0; i < n; i++) {
			cin >> get<0>(aa[i]) >> get<1>(aa[i]);
			get<2>(aa[i]) = i;
		}

		sort(aa.begin(), aa.end(), [](auto a, auto b) {
			return get<0>(b) * get<1>(a) > get<0>(a) * get<1>(b);
		});

		vector< tuple<double, int, int, int> > bb;
		for(auto [ww, cc, ii]: aa) {
			bb.emplace_back((double)cc / ww, ww, cc, ii);
			bb.emplace_back((double)cc / ww * 1.5, ww, cc, ii);
		}
		sort(bb.rbegin(), bb.rend());
		vector<bool> taken(n);
		int curw = 0;
		int curcost = 0;
		for(auto [_, ww, cc, ii]: bb) {
			if(!taken[ii] && curw + ww <= w) {
				curw += ww;
				curcost += cc;
				taken[ii] = true;
			}
		}

		int oldans = calc(aa);

		double maxtemp = 10;
		double temp = maxtemp;
		for(int i = 0; i < 150; i++) {
			auto aanew = aa;
			for(int j = 0; j < (int)(temp * (n + 1) / maxtemp); j++) {
				swap(aanew[rand() % n], aanew[rand() % n]);
			}
			int newans = calc(aanew);
			if(newans > oldans || rand() < RAND_MAX * exp(-(oldans - newans) / temp)) {
				aa = aanew;
				oldans = newans;
			}
			temp *= 0.95;
		}

		cerr << temp << "\n";

		if(curcost > oldans) {
			int cnt = 0;
			for(int i = 0; i < n; i++) {
				if(taken[i]) {
					cnt++;
				}
			}
			cout << cnt << "\n";
			for(int i = 0; i < n; i++) {
				if(taken[i]) {
					cout << i + 1 << " ";
				}
			}
			cout << "\n";
		} else {
			vector<int> ans;
			for(auto [ww, cc, ii]: aa) {
				if(w >= ww) {
					w -= ww;
					ans.push_back(ii);
				}
			}

			cout << ans.size() << "\n";

			for(int x: ans) {
				cout << x + 1 << " ";
			}
			cout << "\n";
		}
	}

	return 0;
}