#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <unordered_set>
#include <tuple>
#include <queue>
#include <set>
#include <cstring>
#include <functional>
#include <random>
#include <chrono>
#include <cassert>
#include <iomanip>
// #include <ext/pb_ds/assoc_container.hpp>

#define ar array
#define all(arr) (arr).begin(), (arr).end()
#define range(i, n) for (int i=0; i < (n); ++i)
#define rall(arr) (arr).rbegin(), (arr).rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

// using namespace __gnu_pbds;
/*
typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
*/

const ll INF = 1e18;
const int INFi = 2e9;
const int maxN = 2e5 + 1;
const int md2 = 998244353;
const int md3 = 1e9 + 7;

double getTime() { return clock() / (double) CLOCKS_PER_SEC; }

void solve() {
    int n, m, s;
    cin >> n >> m >> s;
    vector<int> a(m);
    range(i, m) cin >> a[i];
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    int k = a.size();
    vector<pair<int, int>> events;
    range(i, k) {
        int x = a[i];
        events.emplace_back(x, 1);
        events.emplace_back(x + m, -1);
    }
    sort(all(events));
    int cnt = 0;
    int previous = m;
    int ans = 0;
    for (auto &[x, t] : events) {
        if (x > n) break;
        if (x > previous) {
            if (cnt >= m - s) ans += x - previous;
            previous = x;
        }
        if (t > 0) cnt++;
        else cnt--;
    }
    if (cnt >= m - s) ans += n + 1 - previous;
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    // cout << setprecision(15) << fixed;
    int tests = 1;
    // cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}