//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("fma,avx,avx2")
#include <iostream>
#include <random>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
//#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

mt19937 rnd(6547389847627);

typedef long long ll;

#define int long long
#define ld double
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define sqr(a) (a) * (a)
#define debug(x) cout << #x << ": " << x << '\n'

template<class t, class u>
void amax(t &a, u b) { if (a < b) a = b; }

template<class t, class u>
void amin(t &a, u b) { if (b < a) a = b; }

template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

#define one(x) memset(x, -1, sizeof(x))
#define zero(x) memset(x, 0, sizeof(x))
/*#define MAX_SZ 100

void solve() {
    int n, W;
    cin >> n >> W;
    //c,w
    map<pi, pair<pi, int>> mp;
    vector<pair<int, int>> dp = {{0, 0}};
    for (int i = 0; i < n; i++) {
        int w, c;
        cin >> w >> c;
        int sz = dp.size();
        for (int j = 0; j < sz; ++j) {
            cout << dp[j].first << " " << dp[j].second << "\n";
            int cn = dp[j].first + c;
            int wn = dp[j].second + w;
            if (wn * 2 <= 3 * W) {
                mp[{cn, wn}] = {dp[j], i};
                dp.push_back({cn, wn});
            }
        }
        sort(dp.rbegin(), dp.rend());
        while (dp.size() > MAX_SZ) {
            dp.pop_back();
        }
    }
    pi best = dp[0];
    vi ans;
    while (best.x != 0) {
        auto tmp = mp[best];
        ans.push_back(tmp.y);
        best = tmp.x;
    }
    cout << sz(ans) << '\n';
    for (auto &el : ans) {
        cout << el + 1 << ' ';
    }
    cout << '\n';
}*/
struct pt {
    int x, y;
};

inline int area(pt a, pt b, pt c) {
    return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

inline bool intersect_1(int a, int b, int c, int d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    return max(a, c) <= min(b, d);
}

bool intersect(pt a, pt b, pt c, pt d) {
    return intersect_1(a.x, b.x, c.x, d.x);
}

void ask(int i, int j) {
    cout << i + 1 << ' ' << j + 1 << endl;
}

const int maxn = 310;

int can[maxn][maxn];

int n;
vc<pt> aa;

void check(int ai, int aj) {
    if (ai > aj) swap(ai, aj);
    can[ai][aj] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (!can[i][j]) continue;
            if (ai == i || ai == j || aj == i || aj == j) continue;
            if (intersect(aa[i], aa[j], aa[ai], aa[aj])) {
                can[i][j] = 0;
            }
        }
    }
}

pi get_any() {
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (can[i][j]) {
                return {i, j};
            }
        }
    }
    assert(0);
    return {-1, -1};
}

void check_jury() {
    int i, j;
    cin >> i >> j;
    if (i == 0 && j == 0) exit(0);
    check(i - 1, j - 1);
}

bool cmp(pt a, pt b) {
    return a.x < b.x || a.x == b.x && a.y < b.y;
}


int convex_hull(vector<pt> a) {
    int res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int neg = 0, pos = 0;
            for (int k = 0; k < n; ++k) {
                if (k == i || k == j) {
                    continue;
                }
                if (area(a[i], a[j], a[k]) < 0) {
                    neg++;
                } else {
                    pos++;
                }
            }
            if (neg == 0 || pos == 0) {
                res++;
               // cout << i << " " << j << "\n";
            }
        }
    }
    return 3*n -3 - res;
}

bool get_res() {
    int cnt = convex_hull(aa);
    if (cnt & 1) {
        cout << 1 << endl;
    } else {
        cout << 2 << endl;
    }
    return cnt & 1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    /*int t;
    cin >> t;
    while (t--) {
        solve();
    }*/
    cin >> n;
    aa.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> aa[i].x >> aa[i].y;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            can[i][j] = 1;
        }
    }
    bool res = get_res();
    if (res) {
        pi tmp = get_any();
        check(tmp.x,tmp.y);
        ask(tmp.x, tmp.y);
    }
    while (1) {
        check_jury();
        pi tmp = get_any();
        check(tmp.x,tmp.y);
        ask(tmp.x, tmp.y);
    }
    return 0;
}