﻿#include <iostream>
#include <vector>
#include <iomanip>
#include <ctime>
#include <random>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <cstring>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#include <cmath>
#include <stack>
#include <numeric>
#include <limits.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct Node {
	int val = 0;
	Node *l = nullptr, *r = nullptr;
	Node() {

	}
};

void update(Node *&v, int l, int r, int ind) {
	//cout << l << ' ' << r << '\n';
	if (ind < l || r <= ind)
		return;
	if (l + 1 == r) {
		v->val++;
		return;
	}
	if (v->l == nullptr)
		v->l = new Node(), v->r = new Node();
	update(v->l, l, (l + r) / 2, ind);
	update(v->r, (l + r) / 2, r, ind);
	v->val = v->l->val + v->r->val;
}

int get_sum(Node *v, int l, int r, int a, int b) {
	if (b <= l || r <= a)
		return 0;
	if (a <= l && r <= b)
		return v->val;
	if (v->l == nullptr)
		v->l = new Node(), v->r = new Node();
	return get_sum(v->l, l, (l + r) / 2, a, b) + get_sum(v->r, (l + r) / 2, r, a, b);
}

signed main() {
	int n, m, s;
	cin >> n >> m >> s;
	vector<int> arr(m);
	for (int i = 0; i < m; i++) cin >> arr[i];
	sort(arr.begin(), arr.end());
	arr.resize(unique(arr.begin(), arr.end()) - arr.begin());
	int ans = 0;
	deque<int> q;
	arr.insert(arr.begin(), 0);
	arr.push_back(n + 1);
	Node *v = new Node();
	for (int i = 1; i  + 1 < arr.size(); i++) {
		update(v, 0, 1e9 + 228, arr[i]);
	}
	for (int i = 1; i + 1 < arr.size(); i++) {
		if (arr[i] + m - 1 <= n) {
			int aaa = arr[i] + m - 1;
			if (m - get_sum(v, 0, 1e9 + 228, arr[i], aaa + 1) <= s) {
				ans++;
			}
		}
	}
	for (int i = 0; i + 1 < arr.size(); i++) {
		int x = arr[i], y = arr[i + 1];
		x++, y--;
		if (x <= y) {
			int l = x + m - 1, r = y + m - 1;
			r = min(r, n);
			l = min(l, n + 1);

			if (l != n + 1) {
				//cout << l << ' ' << r << ' ' << x << ' ' << y << '\n';
				if (m - get_sum(v, 0, 1e9 + 228, arr[i + 1], l + 1) <= s)
					ans += min(r - l + 1, y - x + 1);
				else {
					if (m - get_sum(v, 0, 1e9 + 228, arr[i + 1], r + 1) <= s) {
						int l1 = l, r1 = r + 1;
						while (l1 + 1 < r1) {
							int mid = (l1 + r1) / 2;
							if (m - get_sum(v, 0, 1e9 + 228, arr[i + 1], mid + 1) <= s)
								r1 = mid;
							else
								l1 = mid;
						}
						ans += r - r1 + 1;
					}
				}
			}
		}
	}
	cout << ans;
	return 0;
}