#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <tuple>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

using namespace std;

int k;
long long ans = 0;

long long prcalc[16][16];

void gen(int n, int last, vector<int>& a) {
    if (!n) {
        int last = 0;
        int cnt = 0;
        long long x = 1;
        for (auto & i : a) {
            if (i == last) {
                ++cnt;
            }
            else {
                x *= prcalc[cnt][k];
                last = i;
                cnt = 1;
            }
        }
        x *= prcalc[cnt][k];
        ans += x;
        return;
    }
    for (int i = last; n - i >= i; i++) {
        if (!i) {
            continue;
        }
        a.push_back(i);
        gen(n - i, i, a);
        a.pop_back();
    }
    a.push_back(n);
    gen(0, n, a);
    a.pop_back();
}

void solve() {
    int n;
    cin >> n >> k;
    for (int i = 0; i <= k; ++i) {
        prcalc[0][i] = 1;
    }
    for (int i = 1; i <= n; ++i) {
        prcalc[i][0] = 0;
        prcalc[i][1] = 1;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 2; j <= k; ++j) {
            for (int x = 0; x <= i; ++x) {
                prcalc[i][j] += prcalc[i - x][k - 1];
            }
        }
    }
    vector<int> a;
    gen(n, 0, a);
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
