#include <iostream>
#include <map>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

set <vector <int>> a;

void gen(int n, vector <int> b)
{
    if (n == 0)
    {
        sort(b.begin(), b.end());
        a.insert(b);
        return;
    }

    for (int i = 1; i <= n; i++)
    {
        vector <int> c = b;
        c.push_back(i);
        gen(n - i, c);
    }
}

unsigned long long fact(unsigned long long x, unsigned long long y)
{
    unsigned long long pr = 1;

    for (int i = y + 1; i <= x; i++)
        pr *= i;

    return pr;
}

unsigned long long power(unsigned long long n, unsigned long long k)
{
    unsigned long long b = 1;

    for (int i = 1; i <= k; i++)
        b *= n;

    return b;
}

int main()
{
    unsigned long long n, k;

    cin >> n >> k;

    gen(n, {});

    unsigned long long sum = 0;


    for (auto i : a)
    {
        map <long long, long long> b;

        for (auto j : i)
            b[j]++;

        unsigned long long pr = 1;

        for (auto j : b)
        {
            pr *= max(1ULL, fact(k + j.second - 1, j.second) / fact(k + j.second - 1 - j.second, 1));
            //cout << "" << power(k, j.second) / fact(j.second - 1) << endl;
        }



        sum += pr;
        /*cout << "------------------------" << endl;
        for (int j = 0; j < i.size(); j++)
        {
            cout << i[j] << ' ';
        }
        cout << endl;
        cout << pr << endl;
        cout << "-------------------" << endl;*/
    }

    cout << sum << endl;

    return 0;
}
