#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define x first
#define y second
using ll = long long;
using dbl = long double;
#define int ll

#ifndef DEBUG
#define cerr if (0) cout
#endif


struct state {
	int w, c, par;
	state(int x, int y, int z) : w(x), c(y), par(z) {}
};
bool operator<(state a, state b) {
	return a.w < b.w;
}

const int N = 1e5 + 10;
int w[N], cost[N];
vector<state> k[N];

void solve() {
	// w, cost
	int n, W;
	cin >> n >> W;
	k[0].clear();
	k[0].emplace_back(0, 0, false);
	for (int i = 0; i < n; ++i) {
		cin >> w[i] >> cost[i];
		vector<state> tmp;
		for (auto e : k[i]) {
			tmp.emplace_back(e.w, e.c, false);
			tmp.emplace_back(e.w + w[i], e.c + cost[i], true);
		}
		k[i + 1].clear();
		sort(all(tmp));
		for (auto e : tmp) {
			if (k[i + 1].size() && k[i + 1].back().c >= e.c) {
				continue;
			}
			while (k[i + 1].size() >= 2 && k[i + 1][k[i + 1].size() - 2].w * 3 >= e.w * 2 && k[i + 1].back().c <= e.c) {
				k[i + 1].pop_back();
			}
			k[i + 1].push_back(e);
		}
	}
	// for (auto e : k[n]) {
	// 	cout << e.w << " " << e.c << " " << e.par << endl;
	// }
	vector<int> answer;
	W = 3 * W / 2;
	for (; n > 0; n--) {
		// cout << "# " << n << " " << W << endl;
		// cout << " " << k[n].back().w << endl;
		auto it = upper_bound(all(k[n]), state(W, 0, 0));
		assert(it != k[n].begin());
		--it;
		// cout << n << " " << it->w << " " << it->c << " " << it->par << endl;
		if (it->par) {
			answer.push_back(n);
			W -= w[n - 1];
		}
	}
	reverse(all(answer));
	cout << answer.size() << "\n";
	for (auto e : answer) {
		cout << e << " ";
	}
	cout << "\n";
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int tn;
	cin >> tn;
	while (tn--) {
		solve();
	}
	// cout << 1000 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}