#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define x first
#define y second
using ll = long long;
using dbl = long double;
#define int ll

#ifndef DEBUG
#define cerr if (0) cout
#endif


struct state {
	int w, c, par;
	state(int x, int y, int z) : w(x), c(y), par(z) {}
	state() : state(0, 0, 0) {}
};
bool operator<(state a, state b) {
	return a.w < b.w;
}

const int N = 1e5 + 10;
const int K = 300;
const int INF = 1e18;

vector<int> pw;
int w[N], cost[N];
vector<state> k[N];
state g[K];

void solve() {
	// w, cost
	int n, W;
	cin >> n >> W;
	W = 3 * W / 2;
	k[0].clear();
	k[0].emplace_back(0, 0, false);
	for (int i = 0; i < n; ++i) {
		cin >> w[i] >> cost[i];
		vector<state> tmp;
		for (auto e : k[i]) {
			tmp.emplace_back(e.w, e.c, false);
			tmp.emplace_back(e.w + w[i], e.c + cost[i], true);
		}
		fill_n(g, K, state(0, -INF, 0));
		for (auto e : tmp) {
			if (e.w > W) {
				continue;
			}
			int pos = (int)(lower_bound(all(pw), e.w) - pw.begin());
			if (g[pos].c < e.c) {
				g[pos] = e;
			}
		}
		tmp.clear();
		for (int j = 0; j < K; ++j) {
			if (g[j].c >= 0) {
				tmp.push_back(g[j]);
			}
		}
		sort(all(tmp));
		k[i + 1].clear();
		for (auto e : tmp) {
			if (k[i + 1].empty() || k[i + 1].back().c < e.c) {
				k[i + 1].push_back(e);
			}
		}
	}
	// for (auto e : k[n]) {
	// 	cout << e.w << " " << e.c << " " << e.par << endl;
	// }
	vector<int> answer;
	for (; n > 0; n--) {
		// cout << "# " << n << " " << W << endl;
		// cout << " " << k[n].back().w << endl;
		auto it = upper_bound(all(k[n]), state(W, 0, 0));
		assert(it != k[n].begin());
		--it;
		// cout << it->c;
		// exit(0);
		// cout << n << " " << it->w << " " << it->c << " " << it->par << endl;
		if (it->par) {
			answer.push_back(n);
			W -= w[n - 1];
		}
	}
	reverse(all(answer));
	cout << answer.size() << "\n";
	for (auto e : answer) {
		cout << e << " ";
	}
	cout << "\n";
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	const double alpha = 1.2;
	for (int i = 1; pow(alpha, i) < 2e12; ++i) {
		pw.push_back((int)pow(alpha, i));
	}
	// cout << pw.size() << endl;
	// return 0;
	// for (int i = 0; i < K; ++i) {
	// 	pw.push_back(i);
	// }
	int tn;
	cin >> tn;
	while (tn--) {
		solve();
	}
#ifdef DEBUG
	cout << 1000 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}