﻿#include <iostream>
using namespace std;
#pragma warning(disable : 4996)

const int N = 2e5 + 2;

//int a[N], b[N];
int a[20], b[20];

int ans = 0;

void backtrack(int index, int n, int k, int sum) {
	if (sum == 0) {
		ans++;
		return;
	}
	for (int i = 1; i <= a[index - 1] && i <= sum; i++) {
		for (int j = 1; j <= k; j++) {
			if (i == a[index - 1] && j > b[index - 1]) {
				break;
			}
			a[index] = i;
			b[index] = j;
			backtrack(index + 1, n, k, sum - i);
		}
	}
}

void solve() {
	int n, k;
	cin >> n >> k;
	a[0] = n + 1;
	b[0] = k + 1;
	backtrack(1, n, k, n);
	cout << ans << endl;
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}