#include <iostream>
#include <vector>
#include <queue>


using namespace std;

const int N = 500000 + 17;
long long result[N];
long long sets[N][N];

int main() {
    long long n, m, k;
    cin >> n >> m >> k;

    if (n == 1) {
        cout << 1;
        return 0;
    } else if (n == 2) {
        cout << 1 << ' ' << 2;
        return 0;
    } 

    vector<long long> gr [n];

    long long x;
    for (long long i = 0; i < n; ++i) {
        cin >> x;
    }

    for (long long i = 0; i < m; ++i) {
        long long u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    queue<long long> q;
    q.push(0);
    result[0] = 1;

    for (long long y: gr[0]) {
        sets[y][0] = 1;
    }

    while (q.size()) {
        long long elem = q.front();
        q.pop();

        for (long long y: gr[elem]) {
            if (result[y] == 0) {
                long long slava = 0;
                for (long long z = result[elem]; z < k; ++z) {
                    if (sets[y][z] == 0) {
                        slava = z;
                        break;
                    }
                }
                result[y] = slava + 1;
                for (long long iterator: gr[y]) {
                    sets[iterator][slava] = 1;
                }
                q.push(y);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << result[i] << ' ';
    }

    return 0;

}